<%@ include file="/WEB-INF/layouts/default-html5/core/tagDefinitions.jsp" %><%@ include file="/WEB-INF/layouts/default-html5/core/commonVariables.jsp" %>
<!-- Start ${pageScope.sscCurrentPage} -->
	<div id="registerFormGuts" class="panel panel-primary flush">
		<div class="panel-heading">
			<h3 class="panel-title"><bean:message key="customer.newCustomers" bundle="/customer"/></h3>
		</div>
		<div class="panel-body">

			<%--Original request--%>
			<html:hidden name="registerForm" property="originalRequest"/>

			<%--Cross-site request forgery token--%>
			<html:hidden name="registerForm" property="csrfToken" value="${sessionScope.csrfToken}"/>

			<%--User name/email field--%>
			<div class="form-group">
				<label for="registerUserName" class="control-label">
					<c:if test="${keepUserNameAndEmailInSync eq '1'}">
						<bean:message key="customer.email" bundle="/customer"/>:
					</c:if>
					<c:if test="${keepUserNameAndEmailInSync ne '1'}">
						<bean:message key="customer.userName" bundle="/customer"/>:
					</c:if>
				</label>

				<input type="email" id="registerUserName" class="form-control" name="userName" value="${registerForm.userName}">

			</div>
			
			<c:if test="${empty settings.map.requireEmailActivation || settings.map.requireEmailActivation ne '1'}">

				<%--Password field--%>
				<div class="form-group">
					<label for="registerDecryptedPassword" class="control-label">
						<bean:message key="customer.password" bundle="/customer"/>:
					</label>
	
					<html:password styleId="registerDecryptedPassword" name="registerForm" property="decryptedPassword" styleClass="form-control"/>
	
				</div>
	
				<%--Confirm Password field--%>
				<div class="form-group">
					<label for="registerConfirmPassword" class="control-label" style="padding-top:0;">
						<bean:message key="customer.confirmPassword" bundle="/customer"/>:
					</label>
	
					<html:password styleId="registerConfirmPassword" name="registerForm" property="confirmPassword" styleClass="form-control"/>
	
				</div>
			</c:if>

	<%--Emailer add subscriber opt-in prompt--%>
	<%
		java.util.Properties appComponents = (java.util.Properties) application.getAttribute("appComponents");
		String emailerProcessorImplementer = appComponents.getProperty("emailerProcessorImplementer");
		pageContext.setAttribute("emailerProcessorImplementer", emailerProcessorImplementer);
	%>
	<c:if test="${(settings.map.emailerCustomerRegistration eq 'subscribeOptIns' and fn:endsWith(emailerProcessorImplementer, 'EmailerProcessor'))
	 	or (settings.map.constantContactCustomerRegistration eq 'subscribeOptIns' and fn:endsWith(emailerProcessorImplementer, 'ConstantContactProcessor'))
	 	or (settings.map.mailChimpCustomerRegistration eq 'subscribeOptIns' and fn:endsWith(emailerProcessorImplementer, 'MailChimpProcessor'))}">
		<label for="emailerOptInApproval">
			<c:choose>
				<c:when test="${settings.map.emailerCustomerRegistration eq 'subscribeOptIns' and fn:endsWith(emailerProcessorImplementer, 'EmailerProcessor')}">
					${settings.map.emailerCustomerRegistrationOptInPrompt}:
				</c:when>
				<c:when test="${settings.map.constantContactCustomerRegistration eq 'subscribeOptIns' and fn:endsWith(emailerProcessorImplementer, 'ConstantContactProcessor')}">
					${settings.map.constantContactCustomerRegistrationOptInPrompt}:
				</c:when>
                <c:when test="${settings.map.mailChimpCustomerRegistration eq 'subscribeOptIns' and fn:endsWith(emailerProcessorImplementer, 'MailChimpProcessor')}">
                    ${settings.map.mailChimpCustomerRegistrationOptInPrompt}:
                </c:when>
			</c:choose>
		</label>
		<br/>
		<html:radio name="registerForm" property="emailerOptInApproval" styleId="emailerOptInApprovalYes" value="Yes"/>
		 <label for="emailerOptInApprovalYes"><bean:message key="general.yesLabel"/></label>
		<html:radio name="registerForm" property="emailerOptInApproval" styleId="emailerOptInApprovalNo" value="No"/>
		 <label for="emailerOptInApprovalNo"><bean:message key="general.noLabel"/></label>
		 <br/><br/>
	</c:if>

			<%--Captcha Verification--%>
			<c:choose>
				<c:when test="${settings.map.useImageVerificationWithRegistrations eq '1' and settings.map.useLegacyCaptchaMethod eq '1'}">
					<label for="textFromImage">
						<bean:message key="security.textFromImage" />:
					</label><br>
					<input type="text" id="textFromImage" name="textFromImage" class="form-control"/><br />
					<img class="challengeImage img-responsive" alt="Challenge Image" src="${secureURL}/Jcaptcha.do"/><br />
					<bean:message key="security.textFromImageInstructions" /><br /><br />
				</c:when>
				<c:when test="${settings.map.useImageVerificationWithRegistrations eq '1'}">
					<script src="https://www.google.com/recaptcha/api.js" async defer></script>
					<div class="g-recaptcha" data-sitekey="${settings.map.recaptchaSiteKey}"></div>
				</c:when>
			</c:choose>

		</div>
		<div class="panel-footer clearfix">

			<%--Submit button--%>
			<span id="registerButton" class="buttonWrap"><input type="submit" class="btn btn-primary" value="<bean:message key="customer.registerButton" bundle="/customer"/>"/></span>

			<c:if test="${fn:startsWith(pageTitleKey, 'page.checkout') and settings.map.forceLogin ne '1'}">
				<div id="declineAccountLink" class="panelFooterText">
					<ssc:link href="${secureURL}/CheckoutDeclineLogin.do" styleClass="pull-right"><bean:message key="checkout.declineLoginHeadline" bundle="/order"/></ssc:link>
				</div>
			</c:if>
		</div>
	</div>
<!-- End ${pageScope.sscCurrentPage} -->
