<%@ include file="/WEB-INF/layouts/default-html5/core/tagDefinitions.jsp" %><%@ include file="/WEB-INF/layouts/default-html5/core/commonVariables.jsp" %>
<!-- Start ${pageScope.sscCurrentPage} -->
<div id="${cssIDName}" class="expanded attribute<c:if test="${attribute.attributeIsRequired}"> required</c:if>">
	<%-- Display the attribute's name. --%>
	<label class="name">
		<c:out value="${attribute.attributeName}" escapeXml="false" />:
	</label>
	<%-- Display the attribute's options as radio buttons. --%>
	<c:if test="${!empty attribute.attributeOptions and !attribute.attributeOptions['empty']}">
			<c:set var="selectedOptionID" value="${attribute.defaultOptionID}"/>
			<logic:iterate name="attribute" property="attributeOptions" id="option">
				<c:if test="${option.optionIsActive}">
					<%-- Determine if this option's inventory is being tracked. --%>
					<c:if var="trackOption" scope="request" test="false"/>
					<c:if var="trackOptByAttr" scope="request" test="false"/>
					<c:if test="${trackInventory}">
						<c:set var="optSkuKey" value="${product.productID}|${attribute.attributeID}|${option.optionID}|" scope="request"/>
						<c:if var="trackOption" scope="request" test="${!empty product.skuMap[optSkuKey] and product.skuMap[optSkuKey].trackInventory}">
							<c:set var="optSku" scope="request" value="${product.skuMap[optSkuKey]}"/>
						</c:if>
						<c:if test="${!trackOption}">
							<c:set var="optSkuKey" value="${attribute.attributeID}|${option.optionID}|" scope="request"/>
							<c:if var="trackOptByAttr" scope="request" test="${!empty attributeSKUs[optSkuKey] and attributeSKUs[optSkuKey].trackInventory}">
								<c:set var="optSku" scope="request" value="${attributeSKUs[optSkuKey]}"/>
							</c:if>
						</c:if>
					</c:if>
					<c:if test="${option.optionCode eq parameterValue}">
						<c:set var="selectedOptionID" value="${option.optionID}"/>
					</c:if>
					<c:if test="${!denyPurchase}">
						<div class="radio clearfix">
							<label>
								<%-- Radio button. --%>
								<input id="${parameterName}|${option.optionCode}" type="radio"
								<c:if test="${option.optionID eq selectedOptionID}"> checked="checked"</c:if>
								name="${parameterName}"
								value="${option.optionCode}" 
								<c:if test="${attribute.attributeIsRequired}"> required="required"</c:if>/>

								<%-- Option name. --%>
								<c:out value="${option.optionName}" escapeXml="false" />&nbsp;

								<%-- Option price. --%>
								<c:if test="${!empty option.optionUnitPrice && option.optionUnitPrice != 0}">
									<c:choose>
										<c:when test="${product.unitPrice gt 0 && option.optionUnitPrice gt 0}">
											+<fmt:formatNumber type="currency" currencyCode="${currencyCode}" value="${option.optionUnitPrice}"/>
										</c:when>
										<c:when test="${product.unitPrice gt 0 && option.optionUnitPrice lt 0}">
											-<fmt:formatNumber type="currency" currencyCode="${currencyCode}" value="${-1 * option.optionUnitPrice}"/>
										</c:when>
										<c:when test="${product.unitPrice eq 0}">
											<fmt:formatNumber type="currency" currencyCode="${currencyCode}" value="${option.optionUnitPrice}"/>
										</c:when>
									</c:choose>
								</c:if>

								<%-- Option inventory. --%>
								<c:if test="${trackOption or trackOptByAttr}">
									${optSku.inventoryLevel}
									<bean:message key="product.inventoryLevelCompact" bundle="/product"/>
								</c:if>

								<%-- Option image. --%>
								<c:if test="${!empty option.optionSmallImage}">
									<c:choose>
										<c:when test="${!empty option.optionLargeImage}">
											<a href="${option.optionLargeImage}" data-lightbox="${attribute.attributeCode}" title="${option.optionDescription}">
											<img class="img-thumbnail" src="${option.optionSmallImage}"
											<c:if test="${!empty option.optionName}"> title="${option.optionDescription}" alt="${option.optionName}"</c:if> />
											</a>
										</c:when>
										<c:otherwise>
											<img class="img-thumbnail" src="${option.optionSmallImage}"
											<c:if test="${!empty option.optionName}"> title="${option.optionDescription}" alt="${option.optionName}"</c:if> />
										</c:otherwise>
									</c:choose>
								</c:if>

							</label>
						</div>
					</c:if>
				</c:if>
			</logic:iterate>
	</c:if>
</div>
<!-- End ${pageScope.sscCurrentPage} -->
