package com.softslate.commerce.administrator.administrator;

import java.util.Arrays;
import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.softslate.commerce.customer.core.BaseAction;

/**
 * Struts action class corresponding to requests to
 * <code>/administrator/RoleAddForm.do</code>. Creates an empty
 * <code>RoleAddEditForm</code> object.
 * 
 * @author David Tobey
 * 
 */
public class RoleAddFormAction extends BaseAction {

	static Log log = LogFactory.getLog(RoleAddFormAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		if (log.isDebugEnabled())
			log.debug("Starting action.");

		RoleAddEditForm baseForm = (RoleAddEditForm) form;

		if (request.getAttribute("reset") != null
				&& request.getAttribute("reset").equals("true")) {
			Class classDefinition = baseForm.getClass();
			baseForm = (RoleAddEditForm) classDefinition.newInstance();
		}
		
		baseForm.initializeProperties(mapping, request);
		request.setAttribute("roleAddEditForm", baseForm);

		// Create breadcrumbing collection
		Collection bcs = Arrays.asList(new String[] { "Home", "Roles",
				"Add Role" });
		request.setAttribute("breadcrumbs", bcs);
		
		return mapping.findForward("success");
	}
}
