package com.softslate.commerce.administrator.core;

import java.io.Serializable;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import com.softslate.commerce.businessobjects.core.BusinessObjectFactory;
import com.softslate.commerce.businessobjects.core.Settings;
import com.softslate.commerce.customer.core.FormUtils;

/**
 * Provides a number of properties common to forms representing the initial
 * control panel screen for a database table in the administrator. This class is
 * serializable so that the control screen form settings can be maintained
 * through the user's session.
 * 
 * @author David Tobey
 * 
 */
public class BaseSerializableForm extends ActionForm implements Serializable {

	private static final long serialVersionUID = 3760564191513163829L;

	static Log log = LogFactory.getLog(BaseSerializableForm.class);

	private String idField = null;

	private String nameField = null;

	private String childName = null;

	private boolean m2mChild = false;

	private String[] idValues = null;

	private Integer[] idIntegers = null;

	private String parentIDField = null;

	private String parentID = null;

	private String parentKey = null;

	private String manyToManyKey = null;

	private String manyToManyProp = null;

	private String manyToManyClass = null;

	private String joinManyToManyParent = null;

	private Class entity = null;

	private String parentProperty = "";

	private String entityProperty = "";

	private String grandparentIDField = null;

	private String greatGrandparentIDField = null;

	private String[] fields = null;

	private String[] fieldLables = null;

	private String[] displayFields = null;

	private String[] searchableFields = null;

	private String[] searchableIntFields = null;

	private String[] cantSortByFields = new String[0];

	private String itemsPerPage = "15";

	private String firstRow = "1";

	private String searchString = "";

	private String sortByString = null;

	private String sortAscOrDesc = "DESC";

	private String editMode = "false";

	private String outputMode = "screen";

	private String formAction = null;

	private String addFormAction = null;

	private String editFormAction = null;

	private String editDeleteFormAction = null;

	private String childEditAction = null;

	private String assignments = null;

	private String parentName = null;

	private String grandparentName = null;

	private String greatGrandparentName = null;

	private String[] deleteID = null;

	private String[] assigned = null;

	private String parentScreen = null;

	public boolean isM2mChild() {
		return m2mChild;
	}

	public void setM2mChild(boolean child) {
		m2mChild = child;
	}

	public String getParentName() {
		return parentName;
	}

	public void setParentName(String parentName) {
		this.parentName = parentName;
	}

	public String getGrandparentName() {
		return grandparentName;
	}

	public void setGrandparentName(String grandparentName) {
		this.grandparentName = grandparentName;
	}

	public String getGreatGrandparentName() {
		return greatGrandparentName;
	}

	public void setGreatGrandparentName(String greatGrandparentName) {
		this.greatGrandparentName = greatGrandparentName;
	}

	public String[] getCantSortByFields() {
		return cantSortByFields;
	}

	public void setCantSortByFields(String[] cantSortByFields) {
		this.cantSortByFields = cantSortByFields;
	}

	public String getAssignments() {
		return assignments;
	}

	public void setAssignments(String assignments) {
		this.assignments = assignments;
	}

	public String[] getDeleteID() {
		return deleteID;
	}

	public void setDeleteID(String[] deleteID) {
		this.deleteID = deleteID;
	}

	public String[] getAssigned() {
		return assigned;
	}

	public void setAssigned(String[] assigned) {
		this.assigned = assigned;
	}

	public String getIdField() {
		return idField;
	}

	public void setIdField(String idField) {
		this.idField = idField;
	}

	public String getParentIDField() {
		return parentIDField;
	}

	public void setParentIDField(String parentIDField) {
		this.parentIDField = parentIDField;
	}

	public String getGrandparentIDField() {
		return grandparentIDField;
	}

	public void setGrandparentIDField(String grandparentIDField) {
		this.grandparentIDField = grandparentIDField;
	}

	public String getGreatGrandparentIDField() {
		return greatGrandparentIDField;
	}

	public void setGreatGrandparentIDField(String greatGrandparentIDField) {
		this.greatGrandparentIDField = greatGrandparentIDField;
	}

	public String[] getFields() {
		return fields;
	}

	public void setFields(String[] fields) {
		this.fields = fields;
	}

	public String[] getFieldLables() {
		return fieldLables;
	}

	public void setFieldLables(String[] fieldLables) {
		this.fieldLables = fieldLables;
	}

	public String[] getDisplayFields() {
		return displayFields;
	}

	public void setDisplayFields(String[] displayFields) {
		this.displayFields = displayFields;
	}

	public String getItemsPerPage() {
		return itemsPerPage;
	}

	public void setItemsPerPage(String itemsPerPage) {
		this.itemsPerPage = itemsPerPage;
	}

	public String getFirstRow() {
		return firstRow;
	}

	public void setFirstRow(String firstRow) {
		this.firstRow = firstRow;
	}

	public String getSearchString() {
		return searchString;
	}

	public void setSearchString(String searchString) {
		this.searchString = searchString;
	}

	public Class getEntity() {
		return entity;
	}

	public void setEntity(Class entity) {
		this.entity = entity;
	}

	public String getManyToManyKey() {
		return manyToManyKey;
	}

	public void setManyToManyKey(String manyToManyKey) {
		this.manyToManyKey = manyToManyKey;
	}

	public String getManyToManyProp() {
		return manyToManyProp;
	}

	public void setManyToManyProp(String manyToManyProp) {
		this.manyToManyProp = manyToManyProp;
	}

	public String getParentID() {
		return parentID;
	}

	public void setParentID(String parentID) {
		this.parentID = parentID;
	}

	public String[] getSearchableFields() {
		return searchableFields;
	}

	public void setSearchableFields(String[] searchableFields) {
		this.searchableFields = searchableFields;
	}

	public String[] getSearchableIntFields() {
		return searchableIntFields;
	}

	public void setSearchableIntFields(String[] searchableIntFields) {
		this.searchableIntFields = searchableIntFields;
	}

	public String getSortByString() {
		return sortByString;
	}

	public void setSortByString(String sortByString) {
		this.sortByString = sortByString;
	}

	public String getSortAscOrDesc() {
		return sortAscOrDesc;
	}

	public void setSortAscOrDesc(String sortAscOrDesc) {
		this.sortAscOrDesc = sortAscOrDesc;
	}

	public String getEditMode() {
		return editMode;
	}

	public void setEditMode(String editMode) {
		this.editMode = editMode;
	}

	public String getOutputMode() {
		return outputMode;
	}

	public void setOutputMode(String outputMode) {
		this.outputMode = outputMode;
	}

	public String getFormAction() {
		return formAction;
	}

	public void setFormAction(String formAction) {
		this.formAction = formAction;
	}

	public String getAddFormAction() {
		return addFormAction;
	}

	public void setAddFormAction(String addFormAction) {
		this.addFormAction = addFormAction;
	}

	public String getEditDeleteFormAction() {
		return editDeleteFormAction;
	}

	public void setEditDeleteFormAction(String editDeleteFormAction) {
		this.editDeleteFormAction = editDeleteFormAction;
	}

	public String getEditFormAction() {
		return editFormAction;
	}

	public void setEditFormAction(String editFormAction) {
		this.editFormAction = editFormAction;
	}

	public String getChildEditAction() {
		return childEditAction;
	}

	public void setChildEditAction(String childEditAction) {
		this.childEditAction = childEditAction;
	}

	public String getManyToManyClass() {
		return manyToManyClass;
	}

	public void setManyToManyClass(String manyToManyClass) {
		this.manyToManyClass = manyToManyClass;
	}

	public String getParentKey() {
		return parentKey;
	}

	public void setParentKey(String parentKey) {
		this.parentKey = parentKey;
	}

	public String[] getIdValues() {
		return idValues;
	}

	public void setIdValues(String[] idValues) {
		this.idValues = idValues;
	}

	public Integer[] getIdIntegers() {
		return idIntegers;
	}

	public void setIdIntegers(Integer[] idIntegers) {
		this.idIntegers = idIntegers;
	}

	public String getEntityProperty() {
		return entityProperty;
	}

	public void setEntityProperty(String entityProperty) {
		this.entityProperty = entityProperty;
	}

	public String getParentProperty() {
		return parentProperty;
	}

	public void setParentProperty(String parentProperty) {
		this.parentProperty = parentProperty;
	}

	public String getChildName() {
		return childName;
	}

	public void setChildName(String childName) {
		this.childName = childName;
	}

	public String getNameField() {
		return nameField;
	}

	public void setNameField(String nameField) {
		this.nameField = nameField;
	}

	public String getParentScreen() {
		return parentScreen;
	}

	public void setParentScreen(String parentScreen) {
		this.parentScreen = parentScreen;
	}

	public String getJoinManyToManyParent() {
		return joinManyToManyParent;
	}

	public void setJoinManyToManyParent(String joinManyToManyParent) {
		this.joinManyToManyParent = joinManyToManyParent;
	}

	private FormUtils formUtils = null;

	public FormUtils getFormUtils(HttpServletRequest request) {
		if (formUtils != null) {
			return formUtils;
		}
		BusinessObjectFactory bof = (BusinessObjectFactory) request
				.getAttribute("businessObjectFactory");
		formUtils = (FormUtils) bof.createUtilsObject("formUtilsImplementer");
		return formUtils;
	}

	public void setProperties(HttpServletRequest request) {

		// Set various ID fields
		try {
			setIdValues((String[]) PropertyUtils
					.getProperty(this, getIdField()));
		} catch (Exception e) {
			log.error("Exception trying to set idValues property", e);
		}
		if (getIdValues() != null) {
			setIdIntegers(new Integer[getIdValues().length]);
			for (int i = 0; i < getIdValues().length; i++) {
				if (getIdValues()[i].length() > 0) {
					getIdIntegers()[i] = new Integer(
							Integer.parseInt(getIdValues()[i]));
				}
			}
		}
		if (getParentIDField() != null) {
			try {
				setParentID((String) PropertyUtils.getProperty(this,
						getParentIDField()));
			} catch (Exception e) {
				log.error("Exception trying to set parentID property", e);
			}
		}

		// Set the max number of items to display per page
		int maxRecordsProcessed = 1000;
		String defaultAdminItemsPerPage = "15";
		try {
			Settings settings = (Settings) request.getAttribute("settings");
			maxRecordsProcessed = Integer.parseInt((String) settings
					.getValue("maxRecordsProcessed"));
			defaultAdminItemsPerPage = (String) settings
					.getValue("defaultAdminItemsPerPage");
		} catch (Exception e) {
			log.warn("No maxRecordsProcessed, defaulting to 1000: ", e);
		}

		// Set or retrieve display columns and items per page in the session
		synchronized (request.getSession()) {

			// Skip for API requests, to avoid confusion
			Boolean isApiRequest = (Boolean) request.getAttribute("isApiRequest");
			if (getEntity() != null && (isApiRequest == null || !isApiRequest)) {

				// Save displayed columns in the session
				String[] sessionDisplayFields = (String[]) request.getSession()
						.getAttribute(getEntity().getName() + ".displayFields");
				if (request.getParameter("displayFields") != null) {
					request.getSession().setAttribute(
							getEntity().getName() + ".displayFields",
							getDisplayFields());
				} else if (sessionDisplayFields != null) {
					setDisplayFields(sessionDisplayFields);
				}

				// Save the items per page in the session
				String sessionItemsPerPage = (String) request.getSession()
						.getAttribute(getEntity().getName() + ".itemsPerPage");
				if (request.getParameter("itemsPerPage") != null) {
					if (Integer.parseInt(request.getParameter("itemsPerPage")) <= maxRecordsProcessed) {
						request.getSession().setAttribute(
								getEntity().getName() + ".itemsPerPage",
								getItemsPerPage());
					}
				} else if (sessionItemsPerPage != null) {
					setItemsPerPage(sessionItemsPerPage);
				} else if (defaultAdminItemsPerPage != null) {
					setItemsPerPage(defaultAdminItemsPerPage);
				}
			}

			// Items per page may not exceed the maxRecordsProcessed setting
			if (Integer.parseInt(getItemsPerPage()) > maxRecordsProcessed) {
				ActionMessages messages = new ActionMessages();
				messages.add(
						ActionMessages.GLOBAL_MESSAGE,
						new ActionMessage("messages.perPageCapped", Integer
								.toString(maxRecordsProcessed)));
				request.setAttribute(Globals.MESSAGE_KEY, messages);
				setItemsPerPage(Integer.toString(maxRecordsProcessed));
			}
		}
	}

	public String[] arrayAppend(String[] array, String item) {
		if (!java.util.Arrays.asList(array).contains(item)) {
			String[] newArray = new String[array.length + 1];
			for (int i = 0; i < array.length; i++) {
				newArray[i] = array[i];
			}
			newArray[array.length] = item;
			return newArray;
		}
		return array;
	}

	public String[] arrayPrepend(String[] array, String item) {
		if (!java.util.Arrays.asList(array).contains(item)) {
			String[] newArray = new String[array.length + 1];
			newArray[0] = item;
			for (int i = 0; i < array.length; i++) {
				newArray[i + 1] = array[i];
			}
			return newArray;
		}
		return array;
	}

	public String[] arrayRemove(String[] array, String item) {
		int index = java.util.Arrays.asList(array).indexOf(item);
		if (index > -1) {
			String[] newArray = new String[array.length - 1];
			System.arraycopy(array, 0, newArray, 0, index);
			System.arraycopy(array, index+1, newArray, index,
					newArray.length - index);
			return newArray;
		}
		return array;
	}

	public Character containsUnsafeCharacter(String string,
			HttpServletRequest request) {
		Settings settings = (Settings) request.getAttribute("settings");
		String unsafeCharacters = (String) settings
				.getValue("unsafeCharacters");
		return getFormUtils(request)
				.containsCharacter(string, unsafeCharacters);
	}

}
