package com.softslate.commerce.administrator.customer;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import com.softslate.commerce.administrator.core.BaseSerializableForm;
import com.softslate.commerce.businessobjects.customer.CustomerAddress;

/**
 * Struts form class corresponding to requests to
 * "/administrator/CustomerAddress.do". Provides properties to control
 * searching, viewing, editing, and deleting records in the
 * <code>sscCustomerAddress</code> table.
 * 
 * @author David Tobey
 * 
 */
public class CustomerAddressForm extends BaseSerializableForm {
	private static final long serialVersionUID = 3256727273196500537L;

	static Log log = LogFactory.getLog(CustomerAddressForm.class);

	private String idField = "customerAddressID";

	private String parentIDField = "customerID";

	private String nameField = "address1";

	private String entityProperty = "customerAddress";

	private Class entity = CustomerAddress.class;

	private String[] searchableIntFields = { "customerAddressID" };

	private String[] searchableFields = { "firstName", "lastName", "status", "organization", "address1", "address2",
			"city", "state", "postalCode", "country", "phone1", "phone2", "email1", "email2", "extra1", "extra2",
			"extra3", "extra4", "extra5", "paymentToken", "creditCardName", "identifier" };

	private String[] fields = { "customerAddressID", "status", "firstName", "lastName", "organization", "address1",
			"address2", "city", "state", "postalCode", "country", "phone1", "phone2", "email1", "email2", "extra1",
			"extra2", "extra3", "extra4", "extra5", "notes", "isDefault", "paymentToken", "creditCardName",
			"creditCardType", "creditCardDate", "creditCardNumberDisplay", "identifier", "isBilling" };

	private String[] fieldLables = { "Address ID", "Status", "First Name", "Last Name", "Organization", "Address 1",
			"Address 2", "City", "State", "Postal Code", "Country", "Phone 1", "Phone 2", "Email 1", "Email 2",
			"Extra 1", "Extra 2", "Extra 3", "Extra 4", "Extra 5", "Notes", "Default?", "Payment Token", "CC Name",
			"CC Type", "CC Date", "CC Display", "Identifier", "Billing?" };

	private String[] displayFields = { "address1", "status", "firstName", "lastName", "isDefault", "isBilling" };

	private String sortByString = "address1";

	private String[] cantSortByFields = { "notes" };

	private String formAction = "/CustomerAddress.do";

	private String addFormAction = "/CustomerAddressAddForm.do";

	private String editFormAction = "/CustomerAddressEditForm.do";

	private String editDeleteFormAction = "/CustomerAddressEditDelete.do";

	private String customerID = "";

	private String[] customerAddressID = null;

	private String[] status = null;

	private String[] firstName = null;

	private String[] lastName = null;

	private String[] organization = null;

	private String[] address1 = null;

	private String[] address2 = null;

	private String[] city = null;

	private String[] state = null;

	private String[] postalCode = null;

	private String[] country = null;

	private String[] phone1 = null;

	private String[] phone2 = null;

	private String[] email1 = null;

	private String[] email2 = null;

	private String[] extra1 = null;

	private String[] extra2 = null;

	private String[] extra3 = null;

	private String[] extra4 = null;

	private String[] extra5 = null;

	private String[] notes = null;

	private String[] isDefault = null;

	private String[] identifier = null;

	public String[] getAddress1() {
		return address1;
	}

	public void setAddress1(String[] address1) {
		this.address1 = address1;
	}

	public String[] getAddress2() {
		return address2;
	}

	public void setAddress2(String[] address2) {
		this.address2 = address2;
	}

	public String[] getCity() {
		return city;
	}

	public void setCity(String[] city) {
		this.city = city;
	}

	public String[] getCountry() {
		return country;
	}

	public void setCountry(String[] country) {
		this.country = country;
	}

	public String[] getEmail1() {
		return email1;
	}

	public void setEmail1(String[] email1) {
		this.email1 = email1;
	}

	public String[] getEmail2() {
		return email2;
	}

	public void setEmail2(String[] email2) {
		this.email2 = email2;
	}

	public String[] getExtra1() {
		return extra1;
	}

	public void setExtra1(String[] extra1) {
		this.extra1 = extra1;
	}

	public String[] getExtra2() {
		return extra2;
	}

	public void setExtra2(String[] extra2) {
		this.extra2 = extra2;
	}

	public String[] getExtra3() {
		return extra3;
	}

	public void setExtra3(String[] extra3) {
		this.extra3 = extra3;
	}

	public String[] getExtra4() {
		return extra4;
	}

	public void setExtra4(String[] extra4) {
		this.extra4 = extra4;
	}

	public String[] getExtra5() {
		return extra5;
	}

	public void setExtra5(String[] extra5) {
		this.extra5 = extra5;
	}

	public String[] getFirstName() {
		return firstName;
	}

	public void setFirstName(String[] firstName) {
		this.firstName = firstName;
	}

	public String[] getLastName() {
		return lastName;
	}

	public void setLastName(String[] lastName) {
		this.lastName = lastName;
	}

	public String[] getNotes() {
		return notes;
	}

	public void setNotes(String[] notes) {
		this.notes = notes;
	}

	public String[] getOrganization() {
		return organization;
	}

	public void setOrganization(String[] organization) {
		this.organization = organization;
	}

	public String[] getPhone1() {
		return phone1;
	}

	public void setPhone1(String[] phone1) {
		this.phone1 = phone1;
	}

	public String[] getPhone2() {
		return phone2;
	}

	public void setPhone2(String[] phone2) {
		this.phone2 = phone2;
	}

	public String[] getPostalCode() {
		return postalCode;
	}

	public void setPostalCode(String[] postalCode) {
		this.postalCode = postalCode;
	}

	public String[] getState() {
		return state;
	}

	public void setState(String[] state) {
		this.state = state;
	}

	public String[] getStatus() {
		return status;
	}

	public void setStatus(String[] status) {
		this.status = status;
	}

	public String[] getIsDefault() {
		return isDefault;
	}

	public void setIsDefault(String[] isDefault) {
		this.isDefault = isDefault;
	}

	private String[] paymentToken = null;

	public String[] getPaymentToken() {
		return paymentToken;
	}

	public void setPaymentToken(String[] paymentToken) {
		this.paymentToken = paymentToken;
	}

	private String[] creditCardName = null;

	public String[] getCreditCardName() {
		return creditCardName;
	}

	public void setCreditCardName(String[] creditCardName) {
		this.creditCardName = creditCardName;
	}

	private String[] creditCardType = null;

	public String[] getCreditCardType() {
		return creditCardType;
	}

	public void setCreditCardType(String[] creditCardType) {
		this.creditCardType = creditCardType;
	}

	private String[] creditCardDate = null;

	public String[] getCreditCardDate() {
		return creditCardDate;
	}

	public void setCreditCardDate(String[] creditCardDate) {
		this.creditCardDate = creditCardDate;
	}

	private String[] creditCardNumberDisplay = null;

	public String[] getCreditCardNumberDisplay() {
		return creditCardNumberDisplay;
	}

	public void setCreditCardNumberDisplay(String[] creditCardNumberDisplay) {
		this.creditCardNumberDisplay = creditCardNumberDisplay;
	}

	private String[] isBilling = null;

	public String[] getIsBilling() {
		return isBilling;
	}

	public void setIsBilling(String[] isBilling) {
		this.isBilling = isBilling;
	}

	public String[] getIdentifier() {
		return identifier;
	}

	public void setIdentifier(String[] identifier) {
		this.identifier = identifier;
	}

	public String getIdField() {
		return idField;
	}

	public void setIdField(String idField) {
		this.idField = idField;
	}

	public String getParentIDField() {
		return parentIDField;
	}

	public void setParentIDField(String parentIDField) {
		this.parentIDField = parentIDField;
	}

	public String[] getFields() {
		return fields;
	}

	public void setFields(String[] fields) {
		this.fields = fields;
	}

	public String[] getFieldLables() {
		return fieldLables;
	}

	public void setFieldLables(String[] fieldLables) {
		this.fieldLables = fieldLables;
	}

	public String[] getDisplayFields() {
		return displayFields;
	}

	public void setDisplayFields(String[] displayFields) {
		this.displayFields = displayFields;
	}

	public String getSortByString() {
		return sortByString;
	}

	public void setSortByString(String sortByString) {
		this.sortByString = sortByString;
	}

	public String[] getCantSortByFields() {
		return cantSortByFields;
	}

	public void setCantSortByFields(String[] cantSortByFields) {
		this.cantSortByFields = cantSortByFields;
	}

	public String getFormAction() {
		return formAction;
	}

	public void setFormAction(String formAction) {
		this.formAction = formAction;
	}

	public String getAddFormAction() {
		return addFormAction;
	}

	public void setAddFormAction(String addFormAction) {
		this.addFormAction = addFormAction;
	}

	public String getEditFormAction() {
		return editFormAction;
	}

	public void setEditFormAction(String editFormAction) {
		this.editFormAction = editFormAction;
	}

	public String getEditDeleteFormAction() {
		return editDeleteFormAction;
	}

	public void setEditDeleteFormAction(String editDeleteFormAction) {
		this.editDeleteFormAction = editDeleteFormAction;
	}

	public String getCustomerID() {
		return customerID;
	}

	public void setCustomerID(String customerID) {
		this.customerID = customerID;
	}

	public String[] getCustomerAddressID() {
		return customerAddressID;
	}

	public void setCustomerAddressID(String[] customerAddressID) {
		this.customerAddressID = customerAddressID;
	}

	public Class getEntity() {
		return entity;
	}

	public void setEntity(Class entity) {
		this.entity = entity;
	}

	public String getEntityProperty() {
		return entityProperty;
	}

	public void setEntityProperty(String entityProperty) {
		this.entityProperty = entityProperty;
	}

	public String getNameField() {
		return nameField;
	}

	public void setNameField(String nameField) {
		this.nameField = nameField;
	}

	public String[] getSearchableFields() {
		return searchableFields;
	}

	public void setSearchableFields(String[] searchableFields) {
		this.searchableFields = searchableFields;
	}

	public String[] getSearchableIntFields() {
		return searchableIntFields;
	}

	public void setSearchableIntFields(String[] searchableIntFields) {
		this.searchableIntFields = searchableIntFields;
	}

	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		if (log.isDebugEnabled())
			log.debug("Starting validation.");
		setProperties(request);
		ActionErrors errors = new ActionErrors();
		return errors;
	}
	
}
