package com.softslate.commerce.administrator.email;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import com.softslate.commerce.administrator.core.BaseAdministratorForm;


/**
 * Struts form class corresponding to requests to
 * "/administrator/EmailOptOutAddForm.do", "/administrator/EmailOptOutEditForm.do",
 * "/administrator/EmailOptOutAdd.do", and "/administrator/EmailOptOutEdit.do".
 * Provides properties corresponding to the fields for a single EmailOptOut
 * record.
 * 
 */
public class EmailOptOutAddEditForm extends BaseAdministratorForm {

	/**
	 * 
	 */
	private static final long serialVersionUID = 629859403441928256L;

	static Log log = LogFactory.getLog(EmailOptOutAddEditForm.class);

	private String emailOptOutID = null;
	
	public String getEmailOptOutID() {
		return emailOptOutID;
	}

	public void setEmailOptOutID(String emailOptOutID) {
		this.emailOptOutID = emailOptOutID;
	}

	private String emailAddress = null;

	public String getEmailAddress() {
		return emailAddress;
	}

	public void setEmailAddress(String emailAddress) {
		this.emailAddress = emailAddress;
	}
	private String createdTime = null;

	public String getCreatedTime() {
		return createdTime;
	}

	public void setCreatedTime(String createdTime) {
		this.createdTime = createdTime;
	}
	private String type = null;

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
		if (log.isDebugEnabled()) log.debug("Starting validation.");
		initializeProperties(mapping, request);
		if (StringUtils.isBlank(getType())) {
			getErrors().add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("errors.required", "Type"));
		}
		if (StringUtils.isBlank(getEmailAddress())) {
			getErrors().add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("errors.required", "Email Address"));
		}
		return getErrors();
	}
}
