package com.softslate.commerce.administrator.ordermanagement;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.softslate.commerce.businessobjects.order.Order;
import com.softslate.commerce.customer.core.BaseForm;
import com.softslate.commerce.customer.order.CheckoutUtils;

public class LoadShippingOptions extends BaseOrderManagementAction {

	static Log log = LogFactory.getLog(LoadShippingOptions.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		BaseForm baseForm = (BaseForm) form;
		baseForm.initializeProperties(mapping, request);
		String forward = wrapOrderManagementAction(form);
		return mapping.findForward(forward);
	}

	public Map processOrderManagementAction(BaseForm baseForm) throws Exception {

		Map results = new HashMap();
		CheckoutUtils checkoutUtils = (CheckoutUtils) baseForm
				.getBusinessObjectFactory().createUtilsObject(
						"checkoutUtilsImplementer");
		OrderManagementUtils orderManagement = (OrderManagementUtils) baseForm
				.getBusinessObjectFactory().createUtilsObject(
						"orderManagementUtilsImplementer");

		// Load the valid shipping methods for the order as it now
		// stands
		if (log.isInfoEnabled())
			log.info("Loading valid shipping options");
		Collection options = checkoutUtils
				.loadShippingOptions(baseForm);

		// Try to find the shipping option that the customer had
		// previously chosen.
		Order order = baseForm.getUser().getOrder();
		Map previousOption = orderManagement
				.findPreviousShippingOption(options, order,
						baseForm);
		if (previousOption != null) {
			PropertyUtils.setProperty(baseForm, "shippingOption",
					previousOption.get("processorClass") + "|"
							+ previousOption.get("code"));
		}
		baseForm.getRequest().setAttribute("shippingOptions", options);
		baseForm.getRequest().setAttribute("shippingForm", baseForm);
		results.put("returnForward", "success");
		return results;

	}

}
