package com.softslate.commerce.administrator.payment;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import com.softslate.commerce.businessobjects.payment.AdminPaymentProcessor;
import com.softslate.commerce.customer.core.BaseAction;
import com.softslate.commerce.customer.core.BaseForm;

/**
 * The Struts action used to process requests to clean the system of old credit
 * card information.
 * 
 * @author David Tobey
 * 
 */
public class CardInfoCleanUpAction extends BaseAction {

	static Log log = LogFactory.getLog(CardInfoCleanUpAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		if (log.isDebugEnabled())
			log.debug("Starting action.");

		BaseForm baseForm = (BaseForm) form;

		AdminPaymentProcessor processor = (AdminPaymentProcessor) baseForm
				.getBusinessObjectFactory().createObject(
						"adminPaymentProcessorImplementer");
		int ordersCleanedUp = processor.purgeCardInfo(PropertyUtils
				.describe(form));

		baseForm.getMessages().add(
				ActionMessages.GLOBAL_MESSAGE,
				new ActionMessage("errors.detail", "Card info for "
						+ Integer.toString(ordersCleanedUp)
						+ " orders cleaned up."));
		saveMessages(baseForm.getRequest(), baseForm.getMessages());

		return mapping.findForward("success");
	}
}
