package com.softslate.commerce.administrator.payment;

import java.util.Properties;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.softslate.commerce.administrator.core.SettingsAction;
import com.softslate.commerce.customer.core.BaseDynaForm;

/**
 * @author David Tobey
 * 
 */
public class SettingsActionPayment extends SettingsAction {

    static Log log = LogFactory.getLog(SettingsActionPayment.class);

    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        if (log.isDebugEnabled())
            log.debug("Starting action.");
        BaseDynaForm baseForm = (BaseDynaForm) form;
        String activePaymentProcessors = (String) baseForm
                .get("activePaymentProcessors");
        if (activePaymentProcessors == null) {
            activePaymentProcessors = "";
        }
        String activePaymentForms = (String) baseForm.get("activePaymentForms");
        if (activePaymentForms == null) {
            activePaymentForms = "";
        }
        String activePaymentFormTemplates = (String) baseForm
                .get("activePaymentFormTemplates");
        if (activePaymentFormTemplates == null) {
            activePaymentFormTemplates = "";
        }
        synchronized (getServlet().getServletContext()) {
            Properties appComponents = (Properties) getServlet()
                    .getServletContext().getAttribute("appComponents");
			Properties appSettings = (Properties) getServlet().getServletContext().getAttribute("appSettings");
			if (appSettings == null || appSettings.getProperty("disableComponentUpdatesFromAdministrator") == null
					|| appSettings.getProperty("disableComponentUpdatesFromAdministrator").equals("0")) {
				if (log.isDebugEnabled())
					log.debug("Changing payment components to : " + activePaymentProcessors + "; " + activePaymentForms
							+ "; " + activePaymentFormTemplates);
				appComponents.setProperty("activePaymentProcessors", activePaymentProcessors);
				appComponents.setProperty("activePaymentForms", activePaymentForms);
				appComponents.setProperty("activePaymentFormTemplates", activePaymentFormTemplates);
				saveComponents(appComponents);
				getServlet().getServletContext().setAttribute("appComponents", appComponents);
			}
        }
        return super.execute(mapping, baseForm, request, response);
    }
}
