package com.softslate.commerce.administrator.product;

import java.util.Arrays;
import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.softslate.commerce.businessobjects.core.BusinessObjectFactory;
import com.softslate.commerce.businessobjects.product.Product;
import com.softslate.commerce.businessobjects.product.ProductProcessor;
import com.softslate.commerce.customer.core.BaseAction;

/**
 * Struts action class corresponding to requests to
 * <code>/administrator/AttributeAddForm.do</code>. Creates an empty
 * <code>AttributeAddEditForm</code> object.
 * 
 * @author David Tobey
 * 
 */
public class AttributeAddFormAction extends BaseAction {

	static Log log = LogFactory.getLog(AttributeAddFormAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		if (log.isDebugEnabled())
			log.debug("Starting action.");

		AttributeAddEditForm baseForm = (AttributeAddEditForm) form;

		if (request.getAttribute("reset") != null
				&& request.getAttribute("reset").equals("true")) {
			Class classDefinition = baseForm.getClass();
			baseForm = (AttributeAddEditForm) classDefinition.newInstance();
		}

		baseForm.initializeProperties(mapping, request);
		baseForm.setProductID(request.getParameter("productID"));
		request.setAttribute("attributeAddEditForm", baseForm);

		// Load the parent if an id is present
		BusinessObjectFactory bof = (BusinessObjectFactory) request
				.getAttribute("businessObjectFactory");
		Product product = null;
		if (log.isDebugEnabled())
			log.debug("Checking for parent: " + baseForm.getProductID());
		if (baseForm.getProductID() != null
				&& baseForm.getProductID().length() > 0) {
			ProductProcessor processor =  bof
					.createObject(ProductProcessor.class);
			product = processor.loadProductFromID(PropertyUtils
					.describe(baseForm));
			request.setAttribute("product", product);
		}

		// Navigation
		if (baseForm.getProductID() != null
				&& baseForm.getProductID().length() > 0) {
			Collection bcs = Arrays.asList(new String[] { "Home", "Products",
					"Product Details", "Attributes", "Add Attribute" });
			request.setAttribute("breadcrumbs", bcs);

		} else {

			// Create breadcrumbing collection
			Collection bcs = Arrays.asList(new String[] { "Home", "Attributes",
					"Add Attribute" });
			request.setAttribute("breadcrumbs", bcs);
		}

		return mapping.findForward("success");
	}
}
