package com.softslate.commerce.administrator.product;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import com.softslate.commerce.administrator.core.BaseAdministratorForm;


/**
 * Struts form class corresponding to requests to
 * "/administrator/ProductSettingAddForm.do",
 * "/administrator/ProductSettingEditForm.do",
 * "/administrator/ProductSettingAdd.do", and
 * "/administrator/ProductSettingEdit.do". Provides properties corresponding to
 * the fields for a single product setting record.
 * 
 * @author David Tobey
 */
public class ProductSettingAddEditForm extends BaseAdministratorForm {
    private static final long serialVersionUID = -8246190132536072849L;

    static Log log = LogFactory.getLog(ProductSettingAddEditForm.class);

    private String parentName = null;

    private String productSettingID = null;

    private String productID = null;

    private String code = null;

    private String name = null;

    private String description = null;

    private String type = null;

    private String valueType = null;

    private String value = null;

    private String integerValue;

    private String smallValue = null;

    private String mediumValue = null;

    private String textValue = null;

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getMediumValue() {
        return mediumValue;
    }

    public void setMediumValue(String mediumValue) {
        this.mediumValue = mediumValue;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSmallValue() {
        return smallValue;
    }

    public void setSmallValue(String smallValue) {
        this.smallValue = smallValue;
    }

    public String getTextValue() {
        return textValue;
    }

    public void setTextValue(String textValue) {
        this.textValue = textValue;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getValueType() {
        return valueType;
    }

    public void setValueType(String valueType) {
        this.valueType = valueType;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public String getProductSettingID() {
        return productSettingID;
    }

    public void setProductSettingID(String productSettingID) {
        this.productSettingID = productSettingID;
    }

    public String getProductID() {
        return productID;
    }

    public void setProductID(String productID) {
        this.productID = productID;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getIntegerValue() {
        return integerValue;
    }

    public void setIntegerValue(String integerValue) {
        this.integerValue = integerValue;
    }

    public ActionErrors validate(ActionMapping mapping,
            HttpServletRequest request) {
        if (log.isDebugEnabled())
            log.debug("Starting validation.");
        initializeProperties(mapping, request);
        if (getCode() == null || getCode().equals("")) {
            getErrors().add(ActionMessages.GLOBAL_MESSAGE,
                    new ActionMessage("errors.required", "Code"));
        }
        if (getValueType() == null || getValueType().equals("")) {
            getErrors().add(ActionMessages.GLOBAL_MESSAGE,
                    new ActionMessage("errors.required", "Type"));
        } else if (getValueType().equals("integerValue")) {
            setIntegerValue(getValue());
            if (!formUtils().isInteger(getIntegerValue())) {
                getErrors().add(
                        ActionMessages.GLOBAL_MESSAGE,
                        new ActionMessage("errors.invalidInteger",
                                getIntegerValue()));
            }
        } else if (getValueType().equals("smallValue")) {
            setSmallValue(getValue());
        } else if (getValueType().equals("mediumValue")) {
            setMediumValue(getValue());
        } else if (getValueType().equals("textValue")) {
            setTextValue(getValue());
        }
        return getErrors();
    }
}
