package com.softslate.commerce.administrator.product;

import java.util.Arrays;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang3.StringEscapeUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import com.softslate.commerce.administrator.core.BaseSerializableForm;
import com.softslate.commerce.businessobjects.product.SKU;

/**
 * Struts form class corresponding to requests to "/administrator/SKU.do".
 * Provides properties to control searching, viewing, editing, and deleting
 * records in the <code>sscSKU</code> table.
 * 
 * @author David Tobey
 */
public class SKUForm extends BaseSerializableForm {
	private static final long serialVersionUID = -3896881647606278411L;

	static Log log = LogFactory.getLog(SKUForm.class);

	private String idField = "skuID";

	private String parentIDField = null;

	private String nameField = "skuNumber";

	private String childName = "Discounts";

	private boolean m2mChild = true;

	private String entityProperty = "sku";

	private Class entity = SKU.class;

	private String[] searchableIntFields = { "skuID", "productID" };

	private String[] searchableFields = { "skuNumber", "skuName", "skuMessage",
			"extra1", "extra2", "extra3" };

	private String[] fields = { "skuID", "productID", "attributeOption1",
			"attributeOption2", "attributeOption3", "attributeOption4",
			"attributeOption5", "skuNumber", "skuName", "skuMessage",
			"trackInventory", "inventoryLevel", "extra1", "extra2", "extra3",
			"notes" };

	private String[] fieldLables = { "SKU ID", "Product", "Attr/Opt 1",
			"Attr/Opt 2", "Attr/Opt 3", "Attr/Opt 4", "Attr/Opt 5",
			"SKU No./Code", "SKU Name", "SKU Message", "Track?", "Level",
			"Extra 1", "Extra 2", "Extra 3", "Notes" };

	private String[] displayFields = { "productID", "attributeOption1",
			"skuNumber", "trackInventory", "inventoryLevel" };

	private String sortByString = "productID";

	private String[] cantSortByFields = { "attributeOption1",
			"attributeOption2", "attributeOption3", "attributeOption4",
			"attributeOption5", "notes" };

	private String sortAscOrDesc = "ASC";

	private String formAction = "/SKU.do";

	private String addFormAction = "/SKUAddForm.do";

	private String editFormAction = "/SKUEditForm.do";

	private String editDeleteFormAction = "/SKUEditDelete.do";

	private String childEditAction = "/Discount.do";

	private String productID = "";

	private String discountID = "";

	private String shippingRuleID = "";

	private String[] skuID = null;

	private String[] attributeOption1 = null;

	private String[] attributeOption2 = null;

	private String[] attributeOption3 = null;

	private String[] attributeOption4 = null;

	private String[] attributeOption5 = null;

	private String[] attributeID1 = null;

	private String[] attributeID2 = null;

	private String[] attributeID3 = null;

	private String[] attributeID4 = null;

	private String[] attributeID5 = null;

	private String[] optionID1 = null;

	private String[] optionID2 = null;

	private String[] optionID3 = null;

	private String[] optionID4 = null;

	private String[] optionID5 = null;

	private String[] skuNumber = null;

	private String[] trackInventory = null;

	private String[] inventoryLevel = null;

	private String[] skuName = null;

	private String[] skuMessage = null;

	private String[] extra1 = null;

	private String[] extra2 = null;

	private String[] extra3 = null;

	private String[] notes = null;

	public String getChildName() {
		return childName;
	}

	public void setChildName(String childName) {
		this.childName = childName;
	}

	public Class getEntity() {
		return entity;
	}

	public void setEntity(Class entity) {
		this.entity = entity;
	}

	public String getEntityProperty() {
		return entityProperty;
	}

	public void setEntityProperty(String entityProperty) {
		this.entityProperty = entityProperty;
	}

	public boolean isM2mChild() {
		return m2mChild;
	}

	public void setM2mChild(boolean child) {
		m2mChild = child;
	}

	public String getNameField() {
		return nameField;
	}

	public void setNameField(String nameField) {
		this.nameField = nameField;
	}

	public String[] getSearchableFields() {
		return searchableFields;
	}

	public void setSearchableFields(String[] searchableFields) {
		this.searchableFields = searchableFields;
	}

	public String[] getSearchableIntFields() {
		return searchableIntFields;
	}

	public void setSearchableIntFields(String[] searchableIntFields) {
		this.searchableIntFields = searchableIntFields;
	}

	public String[] getAttributeOption1() {
		return attributeOption1;
	}

	public void setAttributeOption1(String[] attributeOption1) {
		this.attributeOption1 = attributeOption1;
	}

	public String[] getAttributeOption2() {
		return attributeOption2;
	}

	public void setAttributeOption2(String[] attributeOption2) {
		this.attributeOption2 = attributeOption2;
	}

	public String[] getAttributeOption3() {
		return attributeOption3;
	}

	public void setAttributeOption3(String[] attributeOption3) {
		this.attributeOption3 = attributeOption3;
	}

	public String[] getAttributeOption4() {
		return attributeOption4;
	}

	public void setAttributeOption4(String[] attributeOption4) {
		this.attributeOption4 = attributeOption4;
	}

	public String[] getAttributeOption5() {
		return attributeOption5;
	}

	public void setAttributeOption5(String[] attributeOption5) {
		this.attributeOption5 = attributeOption5;
	}

	public String[] getAttributeID1() {
		return attributeID1;
	}

	public void setAttributeID1(String[] attributeID1) {
		this.attributeID1 = attributeID1;
	}

	public String[] getAttributeID2() {
		return attributeID2;
	}

	public void setAttributeID2(String[] attributeID2) {
		this.attributeID2 = attributeID2;
	}

	public String[] getAttributeID3() {
		return attributeID3;
	}

	public void setAttributeID3(String[] attributeID3) {
		this.attributeID3 = attributeID3;
	}

	public String[] getAttributeID4() {
		return attributeID4;
	}

	public void setAttributeID4(String[] attributeID4) {
		this.attributeID4 = attributeID4;
	}

	public String[] getAttributeID5() {
		return attributeID5;
	}

	public void setAttributeID5(String[] attributeID5) {
		this.attributeID5 = attributeID5;
	}

	public String[] getInventoryLevel() {
		return inventoryLevel;
	}

	public void setInventoryLevel(String[] inventoryLevel) {
		this.inventoryLevel = inventoryLevel;
	}

	public String[] getExtra1() {
		return extra1;
	}

	public void setExtra1(String[] extra1) {
		this.extra1 = extra1;
	}

	public String[] getExtra2() {
		return extra2;
	}

	public void setExtra2(String[] extra2) {
		this.extra2 = extra2;
	}

	public String[] getExtra3() {
		return extra3;
	}

	public void setExtra3(String[] extra3) {
		this.extra3 = extra3;
	}

	public String[] getSkuMessage() {
		return skuMessage;
	}

	public void setSkuMessage(String[] skuMessage) {
		this.skuMessage = skuMessage;
	}

	public String[] getSkuName() {
		return skuName;
	}

	public void setSkuName(String[] skuName) {
		this.skuName = skuName;
	}

	public String[] getNotes() {
		return notes;
	}

	public void setNotes(String[] notes) {
		this.notes = notes;
	}

	public String[] getOptionID1() {
		return optionID1;
	}

	public void setOptionID1(String[] optionID1) {
		this.optionID1 = optionID1;
	}

	public String[] getOptionID2() {
		return optionID2;
	}

	public void setOptionID2(String[] optionID2) {
		this.optionID2 = optionID2;
	}

	public String[] getOptionID3() {
		return optionID3;
	}

	public void setOptionID3(String[] optionID3) {
		this.optionID3 = optionID3;
	}

	public String[] getOptionID4() {
		return optionID4;
	}

	public void setOptionID4(String[] optionID4) {
		this.optionID4 = optionID4;
	}

	public String[] getOptionID5() {
		return optionID5;
	}

	public void setOptionID5(String[] optionID5) {
		this.optionID5 = optionID5;
	}

	public String[] getSkuID() {
		return skuID;
	}

	public void setSkuID(String[] skuID) {
		this.skuID = skuID;
	}

	public String[] getSkuNumber() {
		return skuNumber;
	}

	public void setSkuNumber(String[] skuNumber) {
		this.skuNumber = skuNumber;
	}

	public String[] getTrackInventory() {
		return trackInventory;
	}

	public void setTrackInventory(String[] trackInventory) {
		this.trackInventory = trackInventory;
	}

	public String getIdField() {
		return idField;
	}

	public void setIdField(String idField) {
		this.idField = idField;
	}

	public String getParentIDField() {
		return parentIDField;
	}

	public void setParentIDField(String parentIDField) {
		this.parentIDField = parentIDField;
	}

	public String[] getFields() {
		return fields;
	}

	public void setFields(String[] fields) {
		this.fields = fields;
	}

	public String[] getFieldLables() {
		return fieldLables;
	}

	public void setFieldLables(String[] fieldLables) {
		this.fieldLables = fieldLables;
	}

	public String[] getDisplayFields() {
		return displayFields;
	}

	public void setDisplayFields(String[] displayFields) {
		this.displayFields = displayFields;
	}

	public String[] getCantSortByFields() {
		return cantSortByFields;
	}

	public void setCantSortByFields(String[] cantSortByFields) {
		this.cantSortByFields = cantSortByFields;
	}

	public String getSortAscOrDesc() {
		return sortAscOrDesc;
	}

	public void setSortAscOrDesc(String sortAscOrDesc) {
		this.sortAscOrDesc = sortAscOrDesc;
	}

	public String getSortByString() {
		return sortByString;
	}

	public void setSortByString(String sortByString) {
		this.sortByString = sortByString;
	}

	public String getFormAction() {
		return formAction;
	}

	public void setFormAction(String formAction) {
		this.formAction = formAction;
	}

	public String getAddFormAction() {
		return addFormAction;
	}

	public void setAddFormAction(String addFormAction) {
		this.addFormAction = addFormAction;
	}

	public String getEditFormAction() {
		return editFormAction;
	}

	public void setEditFormAction(String editFormAction) {
		this.editFormAction = editFormAction;
	}

	public String getEditDeleteFormAction() {
		return editDeleteFormAction;
	}

	public void setEditDeleteFormAction(String editDeleteFormAction) {
		this.editDeleteFormAction = editDeleteFormAction;
	}

	public String getProductID() {
		return productID;
	}

	public void setProductID(String productID) {
		this.productID = productID;
	}

	public String getDiscountID() {
		return discountID;
	}

	public void setDiscountID(String discountID) {
		this.discountID = discountID;
	}

	public String getShippingRuleID() {
		return shippingRuleID;
	}

	public void setShippingRuleID(String shippingRuleID) {
		this.shippingRuleID = shippingRuleID;
	}

	public String[] getSKUID() {
		return skuID;
	}

	public void setSKUID(String[] skuID) {
		this.skuID = skuID;
	}

	public String getChildEditAction() {
		return childEditAction;
	}

	public void setChildEditAction(String childEditAction) {
		this.childEditAction = childEditAction;
	}

	public void setProperties(HttpServletRequest request) {
		super.setProperties(request);
		if (getParentIDField() != null
				&& getParentIDField().equals("discountID")) {
			setParentKey("discountImplementer");
			setManyToManyKey("skuDiscountImplementer");
			setManyToManyProp("skuDiscounts");
			setManyToManyClass("com.softslate.commerce.businessobjects.product.SKUDiscount");
			setParentProperty("discount");
		}
		if (getParentIDField() != null
				&& getParentIDField().equals("shippingRuleID")) {
			setParentKey("shippingRuleImplementer");
			setManyToManyKey("skuShippingRuleImplementer");
			setManyToManyProp("skuShippingRules");
			setManyToManyClass("com.softslate.commerce.businessobjects.shipping.SKUShippingRule");
			setParentProperty("shippingRule");
		}

	}

	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		if (log.isDebugEnabled())
			log.debug("Starting validation.");
		ActionErrors errors = new ActionErrors();
		setProperties(request);
		if (getSKUID() != null) {
			for (int i = 0; i < getSKUID().length; i++) {
				if (Arrays.asList(getDisplayFields()).contains("skuNumber")) {
					if (getSkuNumber().length < i + 1
							|| getSkuNumber()[i] == null
							|| getSkuNumber()[i].equals("")) {
						errors.add(ActionMessages.GLOBAL_MESSAGE,
								new ActionMessage("errors.required", "SKU Number"));
					} else {

						// Pipes and = signs are allowed in SKU numbers!
						String stripped = (getSkuNumber()[i].replaceAll("\\|",
								"").replaceAll("=", ""));
						if (containsUnsafeCharacter(stripped, request) != null) {
							errors.add(ActionMessages.GLOBAL_MESSAGE,
									new ActionMessage("errors.unsafeCharacter",
											"The SKU number "
													+ StringEscapeUtils.escapeXml11(getSkuNumber()[i]),
											containsUnsafeCharacter(stripped,
													request)));
						}
					}
				}
			}
		}
		return errors;
	}
}
