package com.softslate.commerce.administrator.shipping;

import java.util.Arrays;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang3.StringEscapeUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import com.softslate.commerce.administrator.core.BaseSerializableForm;
import com.softslate.commerce.businessobjects.shipping.ShippingMethod;

/**
 * Struts form class corresponding to requests to
 * "/administrator/ShippingMethod.do". Provides properties to control searching,
 * viewing, editing, and deleting records in the <code>sscShippingMethod</code>
 * table.
 * 
 * @author David Tobey
 * 
 */
public class ShippingMethodForm extends BaseSerializableForm {
	private static final long serialVersionUID = 3257003241974738992L;

	static Log log = LogFactory.getLog(ShippingMethodForm.class);

	private String idField = "shippingMethodID";

	private String nameField = "name";

	private String childName = "Rates";

	private String entityProperty = "shippingMethod";

	private Class entity = ShippingMethod.class;

	private String[] searchableIntFields = { "shippingMethodID" };

	private String[] searchableFields = { "code", "name", "methodType" };

	private String[] fields = { "code", "name", "minimum", "base",
			"methodType", "isActive", "numberDaysToShip", "methodOrder" };

	private String[] fieldLables = { "Code", "Name", "Minimum", "Base",
			"Method Type", "Active", "Days to Ship", "Order" };

	private String[] displayFields = { "code", "name", "minimum", "base",
			"methodType", "isActive" };

	private String sortByString = "methodOrder,name";

	private String formAction = "/ShippingMethod.do";

	private String addFormAction = "/ShippingMethodAddForm.do";

	private String editFormAction = "/ShippingMethodEditForm.do";

	private String editDeleteFormAction = "/ShippingMethodEditDelete.do";

	private String childEditAction = "/ShippingRate.do";

	private String[] shippingMethodID = null;

	private String[] code = null;

	private String[] name = null;

	private String[] minimum = null;

	private String[] base = null;

	private String[] methodType = null;

	private String[] isActive = null;

	private String[] numberDaysToShip = null;

	private String[] methodOrder = null;

	public String[] getBase() {
		return base;
	}

	public void setBase(String[] base) {
		this.base = base;
	}

	public String[] getCode() {
		return code;
	}

	public void setCode(String[] code) {
		this.code = code;
	}

	public String[] getIsActive() {
		return isActive;
	}

	public void setIsActive(String[] isActive) {
		this.isActive = isActive;
	}

	public String[] getMethodType() {
		return methodType;
	}

	public void setMethodType(String[] methodType) {
		this.methodType = methodType;
	}

	public String[] getMinimum() {
		return minimum;
	}

	public void setMinimum(String[] minimum) {
		this.minimum = minimum;
	}

	public String[] getName() {
		return name;
	}

	public void setName(String[] name) {
		this.name = name;
	}

	public String getIdField() {
		return idField;
	}

	public void setIdField(String idField) {
		this.idField = idField;
	}

	public String[] getFields() {
		return fields;
	}

	public void setFields(String[] fields) {
		this.fields = fields;
	}

	public String[] getFieldLables() {
		return fieldLables;
	}

	public void setFieldLables(String[] fieldLables) {
		this.fieldLables = fieldLables;
	}

	public String[] getDisplayFields() {
		return displayFields;
	}

	public void setDisplayFields(String[] displayFields) {
		this.displayFields = displayFields;
	}

	public String getSortByString() {
		return sortByString;
	}

	public void setSortByString(String sortByString) {
		this.sortByString = sortByString;
	}

	public String getFormAction() {
		return formAction;
	}

	public void setFormAction(String formAction) {
		this.formAction = formAction;
	}

	public String getAddFormAction() {
		return addFormAction;
	}

	public void setAddFormAction(String addFormAction) {
		this.addFormAction = addFormAction;
	}

	public String getEditFormAction() {
		return editFormAction;
	}

	public void setEditFormAction(String editFormAction) {
		this.editFormAction = editFormAction;
	}

	public String getEditDeleteFormAction() {
		return editDeleteFormAction;
	}

	public void setEditDeleteFormAction(String editDeleteFormAction) {
		this.editDeleteFormAction = editDeleteFormAction;
	}

	public String getChildEditAction() {
		return childEditAction;
	}

	public void setChildEditAction(String childEditAction) {
		this.childEditAction = childEditAction;
	}

	public String[] getShippingMethodID() {
		return shippingMethodID;
	}

	public void setShippingMethodID(String[] shippingMethodID) {
		this.shippingMethodID = shippingMethodID;
	}

	public String getChildName() {
		return childName;
	}

	public void setChildName(String childName) {
		this.childName = childName;
	}

	public Class getEntity() {
		return entity;
	}

	public void setEntity(Class entity) {
		this.entity = entity;
	}

	public String getEntityProperty() {
		return entityProperty;
	}

	public void setEntityProperty(String entityProperty) {
		this.entityProperty = entityProperty;
	}

	public String getNameField() {
		return nameField;
	}

	public void setNameField(String nameField) {
		this.nameField = nameField;
	}

	public String[] getSearchableFields() {
		return searchableFields;
	}

	public void setSearchableFields(String[] searchableFields) {
		this.searchableFields = searchableFields;
	}

	public String[] getSearchableIntFields() {
		return searchableIntFields;
	}

	public void setSearchableIntFields(String[] searchableIntFields) {
		this.searchableIntFields = searchableIntFields;
	}

	public String[] getNumberDaysToShip() {
		return numberDaysToShip;
	}

	public void setNumberDaysToShip(String[] numberDaysToShip) {
		this.numberDaysToShip = numberDaysToShip;
	}

	public String[] getMethodOrder() {
		return methodOrder;
	}

	public void setMethodOrder(String[] methodOrder) {
		this.methodOrder = methodOrder;
	}

	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {
		if (log.isDebugEnabled())
			log.debug("Starting validation.");
		setProperties(request);
		ActionErrors errors = new ActionErrors();
		if (getShippingMethodID() != null) {
			for (int i = 0; i < getShippingMethodID().length; i++) {
				if (Arrays.asList(getDisplayFields()).contains("code")) {
					if (getCode().length < i + 1 || getCode()[i] == null
							|| getCode()[i].equals("")) {
						errors.add(ActionMessages.GLOBAL_MESSAGE,
								new ActionMessage("errors.required", "Code"));
					} else if (containsUnsafeCharacter(getCode()[i], request) != null) {
						errors.add(ActionMessages.GLOBAL_MESSAGE,
								new ActionMessage("errors.unsafeCharacter",
										"The code " + StringEscapeUtils.escapeXml11(getCode()[i]),
										containsUnsafeCharacter(getCode()[i],
												request)));
					}
				}
				if (Arrays.asList(getDisplayFields()).contains("name")) {
					if (getName().length < i + 1 || getName()[i] == null
							|| getName()[i].equals("")) {
						errors.add(ActionMessages.GLOBAL_MESSAGE,
								new ActionMessage("errors.required", "Name"));
					}
				}
				if (Arrays.asList(getDisplayFields()).contains("methodType")) {
					if (getMethodType().length < i + 1
							|| getMethodType()[i] == null
							|| getMethodType()[i].equals("")) {
						errors.add(ActionMessages.GLOBAL_MESSAGE,
								new ActionMessage("errors.required",
										"Method type"));
					}
				}
			}
		}
		return errors;
	}
}
