package com.softslate.commerce.administrator.shipping;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import com.softslate.commerce.administrator.core.BaseSerializableForm;
import com.softslate.commerce.businessobjects.shipping.ShippingRate;

/**
 * Struts form class corresponding to requests to
 * "/administrator/ShippingRate.do". Provides properties to control searching,
 * viewing, editing, and deleting records in the <code>sscShippingRate</code>
 * table.
 * 
 * @author David Tobey
 *  
 */
public class ShippingRateForm extends BaseSerializableForm {
    private static final long serialVersionUID = 3257849900287931960L;

    static Log log = LogFactory.getLog(ShippingRateForm.class);

    private String idField = "shippingRateID";

    private String parentIDField = "shippingMethodID";

    private String nameField = "";

    private String entityProperty = "shippingRate";

    private Class entity = ShippingRate.class;

    private String[] searchableIntFields = { "shippingRateID" };

    private String[] searchableFields = { };

    private String[] fields = { "floor", "ceiling", "amount", "isActive" };

    private String[] fieldLables = { "Floor", "Ceiling", "Amount", "Active" };

    private String[] displayFields = { "floor", "ceiling", "amount", "isActive" };

    private String sortByString = "floor";

    private String sortAscOrDesc = "ASC";

    private String formAction = "/ShippingRate.do";

    private String addFormAction = "/ShippingRateAddForm.do";

    private String editFormAction = "/ShippingRateEditForm.do";

    private String editDeleteFormAction = "/ShippingRateEditDelete.do";

    private String shippingMethodID = null;

    private String[] shippingRateID = null;

    private String[] floor = null;

    private String[] ceiling = null;

    private String[] amount = null;

    private String[] isActive = null;

    public String getShippingMethodID() {
        return shippingMethodID;
    }

    public void setShippingMethodID(String shippingMethodID) {
        this.shippingMethodID = shippingMethodID;
    }

    public String getIdField() {
        return idField;
    }

    public void setIdField(String idField) {
        this.idField = idField;
    }

    public String getParentIDField() {
        return parentIDField;
    }

    public void setParentIDField(String parentIDField) {
        this.parentIDField = parentIDField;
    }

    public String[] getFields() {
        return fields;
    }

    public void setFields(String[] fields) {
        this.fields = fields;
    }

    public String[] getFieldLables() {
        return fieldLables;
    }

    public void setFieldLables(String[] fieldLables) {
        this.fieldLables = fieldLables;
    }

    public String[] getDisplayFields() {
        return displayFields;
    }

    public void setDisplayFields(String[] displayFields) {
        this.displayFields = displayFields;
    }

    public String getSortByString() {
        return sortByString;
    }

    public void setSortByString(String sortByString) {
        this.sortByString = sortByString;
    }

    public String getFormAction() {
        return formAction;
    }

    public void setFormAction(String formAction) {
        this.formAction = formAction;
    }

    public String getAddFormAction() {
        return addFormAction;
    }

    public void setAddFormAction(String addFormAction) {
        this.addFormAction = addFormAction;
    }

    public String getEditFormAction() {
        return editFormAction;
    }

    public void setEditFormAction(String editFormAction) {
        this.editFormAction = editFormAction;
    }

    public String getEditDeleteFormAction() {
        return editDeleteFormAction;
    }

    public void setEditDeleteFormAction(String editDeleteFormAction) {
        this.editDeleteFormAction = editDeleteFormAction;
    }

    public String[] getShippingRateID() {
        return shippingRateID;
    }

    public void setShippingRateID(String[] shippingRateID) {
        this.shippingRateID = shippingRateID;
    }

    public String[] getAmount() {
        return amount;
    }

    public void setAmount(String[] amount) {
        this.amount = amount;
    }

    public String[] getCeiling() {
        return ceiling;
    }

    public void setCeiling(String[] ceiling) {
        this.ceiling = ceiling;
    }

    public String[] getFloor() {
        return floor;
    }

    public void setFloor(String[] floor) {
        this.floor = floor;
    }

    public String[] getIsActive() {
        return isActive;
    }

    public void setIsActive(String[] isActive) {
        this.isActive = isActive;
    }

    public String getSortAscOrDesc() {
        return sortAscOrDesc;
    }

    public void setSortAscOrDesc(String sortAscOrDesc) {
        this.sortAscOrDesc = sortAscOrDesc;
    }

    public Class getEntity() {
        return entity;
    }

    public void setEntity(Class entity) {
        this.entity = entity;
    }

    public String getEntityProperty() {
        return entityProperty;
    }

    public void setEntityProperty(String entityProperty) {
        this.entityProperty = entityProperty;
    }

    public String getNameField() {
        return nameField;
    }

    public void setNameField(String nameField) {
        this.nameField = nameField;
    }

    public String[] getSearchableFields() {
        return searchableFields;
    }

    public void setSearchableFields(String[] searchableFields) {
        this.searchableFields = searchableFields;
    }

    public String[] getSearchableIntFields() {
        return searchableIntFields;
    }

    public void setSearchableIntFields(String[] searchableIntFields) {
        this.searchableIntFields = searchableIntFields;
    }

    public ActionErrors validate(ActionMapping mapping,
            HttpServletRequest request) {
        if (log.isDebugEnabled())
            log.debug("Starting validation.");
        setProperties(request);
        ActionErrors errors = new ActionErrors();
        return errors;
    }
}
