package com.softslate.commerce.administrator.tax;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import com.softslate.commerce.administrator.core.BaseSerializableForm;
import com.softslate.commerce.businessobjects.tax.BasicTaxRate;

/**
 * Struts form class corresponding to requests to "/administrator/BasicTax.do".
 * Provides properties to control searching, viewing, editing, and deleting
 * records in the <code>sscBasicTaxRate</code> table.
 * 
 * @author David Tobey
 * 
 */
public class BasicTaxForm extends BaseSerializableForm {
    private static final long serialVersionUID = 3258125847607982386L;

    static Log log = LogFactory.getLog(BasicTaxForm.class);

    private String idField = "basicTaxRateID";

    private String nameField = "city";

    private String entityProperty = "basicTaxRate";

    private Class entity = BasicTaxRate.class;

    private String[] searchableIntFields = { "basicTaxRateID" };

    private String[] searchableFields = { "city", "postalCode" };

	private String[] fields = { "basicTaxRateID", "countryID", "stateID", "city", "postalCode",
            "rate", "isActive" };

	private String[] fieldLables = { "Basic Tax Rate ID", "Country", "State", "City", "Postal Code",
            "Rate", "Active" };

	private String[] displayFields = { "basicTaxRateID", "countryID", "stateID", "city",
            "postalCode", "rate", "isActive" };

    private String sortByString = "countryID,stateID,city,postalCode";

    private String formAction = "/BasicTax.do";

    private String addFormAction = "/BasicTaxAddForm.do";

    private String editFormAction = "/BasicTaxEditForm.do";

    private String editDeleteFormAction = "/BasicTaxEditDelete.do";

    private String[] basicTaxRateID = null;

    private String[] countryID = null;

    private String[] stateID = null;

    private String[] city = null;

    private String[] postalCode = null;

    private String[] rate = null;

    private String[] isActive = null;

    public String getIdField() {
        return idField;
    }

    public void setIdField(String idField) {
        this.idField = idField;
    }

    public String[] getFields() {
        return fields;
    }

    public void setFields(String[] fields) {
        this.fields = fields;
    }

    public String[] getFieldLables() {
        return fieldLables;
    }

    public void setFieldLables(String[] fieldLables) {
        this.fieldLables = fieldLables;
    }

    public String[] getDisplayFields() {
        return displayFields;
    }

    public void setDisplayFields(String[] displayFields) {
        this.displayFields = displayFields;
    }

    public String getSortByString() {
        return sortByString;
    }

    public void setSortByString(String sortByString) {
        this.sortByString = sortByString;
    }

    public String getFormAction() {
        return formAction;
    }

    public void setFormAction(String formAction) {
        this.formAction = formAction;
    }

    public String getAddFormAction() {
        return addFormAction;
    }

    public void setAddFormAction(String addFormAction) {
        this.addFormAction = addFormAction;
    }

    public String getEditFormAction() {
        return editFormAction;
    }

    public void setEditFormAction(String editFormAction) {
        this.editFormAction = editFormAction;
    }

    public String getEditDeleteFormAction() {
        return editDeleteFormAction;
    }

    public void setEditDeleteFormAction(String editDeleteFormAction) {
        this.editDeleteFormAction = editDeleteFormAction;
    }

    public String[] getBasicTaxRateID() {
        return basicTaxRateID;
    }

    public void setBasicTaxRateID(String[] basicTaxRateID) {
        this.basicTaxRateID = basicTaxRateID;
    }

    public String[] getCity() {
        return city;
    }

    public void setCity(String[] city) {
        this.city = city;
    }

    public String[] getCountryID() {
        return countryID;
    }

    public void setCountryID(String[] countryID) {
        this.countryID = countryID;
    }

    public String[] getIsActive() {
        return isActive;
    }

    public void setIsActive(String[] isActive) {
        this.isActive = isActive;
    }

    public String[] getPostalCode() {
        return postalCode;
    }

    public void setPostalCode(String[] postalCode) {
        this.postalCode = postalCode;
    }

    public String[] getRate() {
        return rate;
    }

    public void setRate(String[] rate) {
        this.rate = rate;
    }

    public String[] getStateID() {
        return stateID;
    }

    public void setStateID(String[] stateID) {
        this.stateID = stateID;
    }

    public Class getEntity() {
        return entity;
    }

    public void setEntity(Class entity) {
        this.entity = entity;
    }

    public String getEntityProperty() {
        return entityProperty;
    }

    public void setEntityProperty(String entityProperty) {
        this.entityProperty = entityProperty;
    }

    public String getNameField() {
        return nameField;
    }

    public void setNameField(String nameField) {
        this.nameField = nameField;
    }

    public String[] getSearchableFields() {
        return searchableFields;
    }

    public void setSearchableFields(String[] searchableFields) {
        this.searchableFields = searchableFields;
    }

    public String[] getSearchableIntFields() {
        return searchableIntFields;
    }

    public void setSearchableIntFields(String[] searchableIntFields) {
        this.searchableIntFields = searchableIntFields;
    }

    public ActionErrors validate(ActionMapping mapping,
            HttpServletRequest request) {
        if (log.isDebugEnabled())
            log.debug("Starting validation.");
        setProperties(request);
        ActionErrors errors = new ActionErrors();
        return errors;
    }
}
