package com.softslate.commerce.customer.order;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.softslate.commerce.customer.core.BaseForm;

/**
 * Struts action class for requests to "/CheckoutSettings.do". This action simply returns some useful configuration
 * settings in JSON for clients using the API.
 * <p>
 * The <code>execute</code> method of this class first runs
 * {@link com.softslate.commerce.customer.core.ActionUtils#findCheckoutScreen(BaseForm)} to verifiy that the user has
 * made it this far in the checkout process. It then invokes
 * {@link com.softslate.commerce.customer.order.CheckoutAction#processCheckoutConfirm(BaseForm)} to process the request.
 * 
 * @author David Tobey
 */
public class CheckoutSettingsAction extends CheckoutAction {
	static Log log = LogFactory.getLog(CheckoutSettingsAction.class);

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {
		if (log.isInfoEnabled())
			log.info("Starting action.");
		return mapping.findForward("success");
	}
}
