ALTER TABLE npcSKU ADD skuName VARCHAR(255);
ALTER TABLE npcSKU ADD skuMessage VARCHAR(255);
ALTER TABLE npcSKU ADD extra1 VARCHAR(255);
ALTER TABLE npcSKU ADD extra2 VARCHAR(255);
ALTER TABLE npcSKU ADD extra3 VARCHAR(255);
ALTER TABLE npcProductAttribute ADD productAttributeOrder INT;
UPDATE npcProductAttribute SET productAttributeOrder = productAttributeID;

ALTER TABLE npcAdministrator ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.administrator.AdministratorBean';
ALTER TABLE npcAdministratorRole ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.administrator.AdministratorRoleBean';
ALTER TABLE npcAttribute ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.AttributeBean';
ALTER TABLE npcBasicTaxRate ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.tax.BasicTaxRateBean';
ALTER TABLE npcCategory ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.CategoryBean';
ALTER TABLE npcCategorySetting ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.CategorySettingsBean';
ALTER TABLE npcCountry ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.order.CountryBean';
ALTER TABLE npcCustomer ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.customer.CustomerBean';
ALTER TABLE npcCustomerAddress ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.customer.CustomerAddressBean';
ALTER TABLE npcOption ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.OptionBean';
ALTER TABLE npcOrder ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.order.OrderBean';
ALTER TABLE npcOrderDelivery ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.order.OrderDeliveryBean';
ALTER TABLE npcOrderItem ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.order.OrderItemBean';
ALTER TABLE npcOrderItemAttribute ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.order.OrderItemAttributeBean';
ALTER TABLE npcPayment ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.payment.PaymentBean';
ALTER TABLE npcProduct ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.ProductBean';
ALTER TABLE npcProductAttribute ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.ProductAttributeBean';
ALTER TABLE npcProductCategory ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.ProductCategoryBean';
ALTER TABLE npcProductSetting ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.ProductSettingsBean';
ALTER TABLE npcRole ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.administrator.RoleBean';
ALTER TABLE npcSetting ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.core.SettingBean';
ALTER TABLE npcShippingMethod ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.shipping.ShippingMethodBean';
ALTER TABLE npcShippingRate ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.shipping.ShippingRateBean';
ALTER TABLE npcSKU ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.product.SKUBean';
ALTER TABLE npcState ADD class VARCHAR(255) DEFAULT 'com.softslate.commerce.businessobjects.order.StateBean';

UPDATE npcSetting SET smallValue='2.0.1' WHERE code='dataObjectsVersion';
UPDATE npcSetting SET smallValue='11' WHERE code='genericGridDataSize';
UPDATE npcSetting SET integerValue=9 WHERE code='productListPageSize';
UPDATE npcSetting SET integerValue=9 WHERE code='categoryPageSize';
UPDATE npcSetting SET integerValue=9 WHERE code='searchResultsPageSize';

INSERT INTO npcSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue, class) VALUES ('builtInCategories','Built-In Categories','A comma-separated list of category codes corresponding to categories whose products and other data will be read into the application upon start up and available to all store pages.','SYSTEM', 'textValue',NULL,NULL,NULL,'_features,_popular,_new,_favorites', 'com.softslate.commerce.businessobjects.core.SettingBean');
INSERT INTO npcSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue, class) VALUES ('endSessionOnOrderCompletion','End Session on Order Completion?','If true, customers will be logged out and their session cleared when completing an order.','LOGIC', 'integerValue',0,NULL,NULL,NULL, 'com.softslate.commerce.businessobjects.core.SettingBean');
INSERT INTO npcSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue, class) VALUES ('applyDiscounts','Apply Discounts?','If true, active and applicable discounts will be applied. This is a global switch to turn discounting on and off.','LOGIC', 'integerValue',0,NULL,NULL,NULL, 'com.softslate.commerce.businessobjects.core.SettingBean');
INSERT INTO npcSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue, class) VALUES ('applyDiscountsToTaxableSubtotal','Apply Discounts To Taxable Subtotal?','If true, global discounts will be subtracted from the taxable subtotal in addition to the regular subtotal.','LOGIC', 'integerValue',1,NULL,NULL,NULL, 'com.softslate.commerce.businessobjects.core.SettingBean');
INSERT INTO npcSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue, class) VALUES ('storeSMTPUsername','SMTP Server User Name','Username for SMTP authentication (leave blank if no authentication is required).','STORE', 'mediumValue',NULL,NULL,'',NULL, 'com.softslate.commerce.businessobjects.core.SettingBean');
INSERT INTO npcSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue, class) VALUES ('storeSMTPPassword','SMTP Server Password','Password for SMTP authentication (leave blank if no authentication is required)','STORE', 'mediumValue',NULL,NULL,'',NULL, 'com.softslate.commerce.businessobjects.core.SettingBean');

INSERT INTO npcRole(code, name, description, class)
VALUES('importexportView', 'Import/Export Viewer', 'Allows access to view imports and exports.', 'com.softslate.commerce.businessobjects.administrator.RoleBean');
INSERT INTO npcRole(code, name, description, class)
VALUES('importexportEdit', 'Import/Export Editor', 'Allows access to view and run imports and exports.', 'com.softslate.commerce.businessobjects.administrator.RoleBean');

INSERT INTO npcRole(code, name, description, class)
VALUES('skuView', 'SKU Viewer', 'Allows access to view SKUs (inventory and discounting units).', 'com.softslate.commerce.businessobjects.administrator.RoleBean');
INSERT INTO npcRole(code, name, description, class)
VALUES('skuEdit', 'SKU Editor', 'Allows access to view and edit SKUs (inventory and discounting units).', 'com.softslate.commerce.businessobjects.administrator.RoleBean');

INSERT INTO npcRole(code, name, description, class)
VALUES('discountView', 'Discounts Viewer', 'Allows access to view discounts.', 'com.softslate.commerce.businessobjects.administrator.RoleBean');
INSERT INTO npcRole(code, name, description, class)
VALUES('discountEdit', 'Discounts Editor', 'Allows access to view and edit discounts.', 'com.softslate.commerce.businessobjects.administrator.RoleBean');
