<%@ include file="/WEB-INF/layouts/default-html5/core/tagDefinitions.jsp" %><%@ include file="/WEB-INF/layouts/default-html5/core/commonVariables.jsp" %>

<!-- Start settingsEmail.jsp -->
<c:set var="rowClass" value="row"/>
<c:set var="altRowClass" value="altRow"/>
<c:set var="thisClass" scope="request" value="${altRowClass}"/>

<div class="instructions">
	Use these settings to determine how your store sends various emails, including notification emails and order confirmation emails.
</div>

<br/>

<html:form action="/SettingsProcessEmail" method="post">
	<table class="settingsTable">
		<tr>
			<th class="setting">Setting</th>
			<th class="value">Value</th>
		</tr>
		<logic:iterate name="administratorSettings" id="settingRow" indexId="index">
			<logic:match name="settingRow" property="type" value="EMAIL">
			<logic:notMatch name="settingRow" property="type" value="EMAILER">
				<c:choose>
					<c:when test="${requestScope.thisClass eq altRowClass}"><c:set var="thisClass" scope="request" value="${rowClass}"/></c:when>
					<c:otherwise><c:set var="thisClass" scope="request" value="${altRowClass}"/></c:otherwise>
				</c:choose>
				<c:set var="setting" value="${settingRow}" scope="request"/>
				<ssc:insert page="/WEB-INF/templates/administrator/default/core/setting.jsp" flush="false"/>
			</logic:notMatch>
			</logic:match>
		</logic:iterate>
	</table>
	<logic:present role="superuser,administrator,settingsEdit,settingsEmailEdit">
    	<div class="saveSettings">
			<input type="submit" class="button" value="Save Settings"/>
		</div>
	</logic:present>
</html:form>

<div class="helpLinks">
	<h3 class="administratorSubhead">How Do I ... </h3>
	<ul class="helpLinkList inline">
		<li class="inline">
			<ssc:help type="inline" topic="How Do I ..." title="Customize the order confirmation emails sent by the store">
				<p>The order confirmation emails that are sent out to customers, as well as the notification emails sent to the administrator,
				can be customized by creating custom versions of the JSP templates responsible for creating the emails.</p>
				<p>For details on how to customize JSP templates, visit the chapter on 
				<a href="http://www.softslate.com/documentation/html/creatingCustomLayout.html">Creating a Custom Layout</a> of the User Guide.</p>
				<p>The templates responsible for producing the emails are named "orderEmails.jsp", "orderEmailHTML.jsp" and "orderEmailText.jsp".</p>
			</ssc:help>
		</li>
	</ul>
</div>
<!-- End settingsEmail.jsp -->
