<%@ include file="/WEB-INF/layouts/default-html5/core/tagDefinitions.jsp" %><%@ include file="/WEB-INF/layouts/default-html5/core/commonVariables.jsp" %>

<!-- Start orderFieldColumns.jsp -->
<bean:define id="displayFieldArray" name="mainForm" property="displayFields" type="java.lang.String[]" />
<bean:define id="fieldArray" name="mainForm" property="fields" type="java.lang.String[]" />
<% java.util.Collection displayFieldCollection = java.util.Arrays.asList(displayFieldArray); %>
<logic:iterate collection="<%= fieldArray %>" id="field" indexId="i" type="java.lang.String">
	<% if (displayFieldCollection.contains(field)) { %>
		<td class="dataCell <c:out value="${field}"/>">
			<c:choose>
				<c:when test="${field eq 'orderID'}">
					<c:out value="${item[field]}" />
				</c:when>
				<c:when test="${mainForm.editMode eq 'true'}">
					<c:choose>
						<c:when test="${field eq 'created' or field eq 'lastModified' or field eq 'completed'}">
							<c:out value="${item[field]}" />
							<input type="hidden" name="<c:out value="${field}" />" value="<c:out value="${item[field]}" />"/>
						</c:when>
						<c:when test="${field eq 'state'}">
							<html:select name="item" property="state">
								<option value="">Select</option>
								<option value="">-------------</option>
								<html:options collection="states" property="code" labelProperty="name"/>
							</html:select>
						</c:when>
						<c:when test="${field eq 'country'}">
							<html:select name="item" property="country">
								<option value="">Select</option>
								<option value="">-------------</option>
								<html:options collection="countries" property="code" labelProperty="name"/>
							</html:select>
						</c:when>
						<c:when test="${field eq 'notes'}">
							<textarea rows="2" name="<c:out value="${field}" />"><c:out value="${item[field]}" /></textarea>
						</c:when>
						<c:when test="${field eq 'status'}">
							<select name="status">
								<option value="">[None]</option>
								<c:if var="foundStatus" test="${false}"/>
								<c:forTokens var="stat" varStatus="current" items="${settings.map.possibleOrderStatuses}" delims=",">
									<% pageContext.setAttribute("stat", ((String) pageContext.getAttribute("stat")).trim()); %>
									<option value="<c:out value="${stat}"/>"<c:if test="${stat eq item[field]}"> selected="selected"<c:if var="foundStatus" test="${true}"/></c:if>><c:out value="${stat}"/></option>
								</c:forTokens>
								<c:if test="${!foundStatus}">
									<option value="<c:out value="${item[field]}"/>" selected="selected"><c:out value="${item[field]}"/></option>
								</c:if>
							</select>
						</c:when>
						<c:otherwise>
							<input type="text" name="<c:out value="${field}" />" value="<c:out value="${item[field]}" />"/>
						</c:otherwise>
					</c:choose>
				</c:when>
				<c:otherwise>
					<c:choose>
						<c:when test="${field eq 'total'
										or field eq 'shipping'
										or field eq 'tax'
										or field eq 'taxableSubtotal'
										or field eq 'subtotal'}">
							<input type="hidden" name="<c:out value="${field}"/>" value="<c:out value="${item[field]}"/>"/>
							<fmt:formatNumber type="currency" currencyCode="${currencyCode}"><c:out value="${item[field]}"/></fmt:formatNumber>
						</c:when>
						<c:when test="${field eq 'weight'}">
							<input type="hidden" name="<c:out value="${field}"/>" value="<c:out value="${item[field]}"/>"/>
							<fmt:formatNumber type="number"><c:out value="${item[field]}"/></fmt:formatNumber>
						</c:when>
						<c:when test="${field eq 'userName'}">
							<input type="hidden" name="<c:out value="${field}"/>" value="<c:out value="${item[field]}"/>"/>
							<a href="${settings.map.administratorURL}/CustomerEditForm.do?customerID=${item.customerID}"><c:out value="${item[field]}"/></a>
						</c:when>
						<c:otherwise>
							<input type="hidden" name="<c:out value="${field}"/>" value="<c:out value="${item[field]}"/>"/>
							<c:out value="${item[field]}" />
						</c:otherwise>
					</c:choose>
				</c:otherwise>
			</c:choose>
		</td>
	<% } %>
</logic:iterate>
<!-- End orderFieldColumns.jsp -->
