<%@ include file="/WEB-INF/layouts/default-html5/core/tagDefinitions.jsp" %>
<html:xhtml/>

<!-- Start basic.jsp -->

<script language="JavaScript" type="text/javascript">
<!--
	function setDatabaseParameters(selectBox) {
		if (selectBox.options[selectBox.selectedIndex].value == 'org.hibernate.dialect.SQLServerDialect') {
			document.forms.basicForm.databaseDriver.value = 'net.sourceforge.jtds.jdbc.Driver';
			document.forms.basicForm.databasePort.value = '1433';
		}
		if (selectBox.options[selectBox.selectedIndex].value == 'org.hibernate.dialect.MySQLInnoDBDialect') {
			document.forms.basicForm.databaseDriver.value = 'com.mysql.jdbc.Driver';
			document.forms.basicForm.databasePort.value = '3306';
		}
		if (selectBox.options[selectBox.selectedIndex].value == 'org.hibernate.dialect.MySQLMyISAMDialect') {
			document.forms.basicForm.databaseDriver.value = 'com.mysql.jdbc.Driver';
			document.forms.basicForm.databasePort.value = '3306';
		}
		if (selectBox.options[selectBox.selectedIndex].value == 'org.hibernate.dialect.PostgreSQLDialect') {
			document.forms.basicForm.databaseDriver.value = 'org.postgresql.Driver';
			document.forms.basicForm.databasePort.value = '5432';
		}
		if (selectBox.options[selectBox.selectedIndex].value == 'org.hibernate.dialect.OracleDialect') {
			document.forms.basicForm.databaseDriver.value = 'oracle.jdbc.driver.OracleDriver';
			document.forms.basicForm.databasePort.value = '1521';
			document.forms.basicForm.databaseName.value = 'XE';
		}
	}
//-->
</script>

<h1><bean:message key="installer.heading" bundle="/installer/installer"/></h1>
<p class="instructions">Thank you for downloading SoftSlate Commerce!  Please take a look at the following installation tips. They may help the process go smoothly for you.</p>

<div class="helpLinks">
	<h3 class="administratorSubhead">Installation Tips ... </h3>
	<ul class="helpLinkList inline">
		<li class="inline">
			<ssc:help type="inline" topic="Installation Tips ..." title="JDK and Other Requirements">
				<p>SoftSlate requires the Sun/Oracle JDK. For more information visit our <a href="http://www.softslate.com/documentation/html/systemRequirements.html">full list of system requirements</a>.</p>
			</ssc:help>
		</li>
		<li class="inline">
			<ssc:help type="inline" topic="Installation Tips ..." title="Check file permissions">
				<p>The installer will attempt to write some settings to the following files and directories. 
				First of all, it's a good idea to make sure the application server has <em>writable</em> permission for them.
				While you're at it, you might consider <em>limiting</em> permission for these files to be writable and readable 
				<em>only</em> by the application server's user, for security reasons:</p>
				<p><ul>
					<li>WEB-INF/classes/hibernate.properties and WEB-INF/src/hibernate.properties (database settings)</li>
					<li>WEB-INF/classes/log4j.properties and WEB-INF/src/log4j.properties (log file setting)</li>
					<li>WEB-INF/classes/appSettings.properties and WEB-INF/src/appSettings.properties (encryption key setting and license key)</li>
					<li>WEB-INF/conf/keys (encryption key placed in this directory by default)</li>
					<li>WEB-INF/lucene (if using Advanced Search, the Lucene index goes here by default)</li>
				</ul></p>
			</ssc:help>
		</li>
		<li class="inline">
			<ssc:help type="inline" topic="Installation Tips ..." title="Disable Auto Reload">
				<p>Some application servers can be configured to reload themselves every time any file changes inside /WEB-INF/classes.
				Obviously, the installer will not work so well if it triggers a reload in the middle of modifying the above files,
				so please turn that configuration off. For example in Eclipse's Servers tab, you would uncheck <a href="http://screencast.com/t/JgA9jl8XU">
				this box</a>.</p>
			</ssc:help>
		</li>
		<li class="inline">
			<ssc:help type="inline" topic="Installation Tips ..." title="Memory Settings">
				<p>How much memory have you allocated to your application server's heap size and perm gen size? The installation process
				can be a bit intensive. If it runs out of memory you'll have to delete the database and start over. Best to give it at least
				256MB of heap and 128MB of PermGen space if possible.</p>
			</ssc:help>
		</li>
		<li class="inline">
			<ssc:help type="inline" topic="Installation Tips ..." title="More Help ...">
				<p>If all else fails, check out our <a href="http://www.softslate.com/documentation/html/installationTroubleshooting.html">
				Installation Troubleshooting Tips</a> and our instructions for <a href="http://www.softslate.com/documentation/html/installingManually.html">
				Installing SoftSlate Commerce Manually</a>.</p>
				<p>If that fails, post everything you can about the issue to our <a href="http://www.softslate.com/forums">User Forums</a>
				or email us at <a href="mailto:info@softslate.com">info@softslate.com</a>.</p>
			</ssc:help>
		</li>
	</ul>
</div>
<br/><br/>
<p class="instructions">
The below form asks for some essential information allowing you to install SoftSlate Commerce for the first time.</p>

<html:form styleClass="centeredForm" action="/InstallerBasicProcess" method="post">
	<html:hidden property="databaseDriver"/>
	<html:hidden property="twoWayKeyFile"/>
	<html:hidden value="true" property="testConnection"/>
	<html:hidden value="twoWay" property="paymentEncryptionType"/>
	<html:hidden value="twoWay" property="customerEncryptionType"/>
	<html:hidden value="oneWay" property="administratorEncryptionType"/>
	<html:hidden value="true" property="lockInstaller"/>
    <html:hidden value="USD" property="currecyCode"/>
    <html:hidden value="false" property="initializeLegacyDAOFactory"/>
    <html:hidden value="ssc" property="databaseTablePrefix"/>

	<table id="installerSteps">
<%--		<tr>
		
	<!-- license key heading -->
	<c:choose>
		<c:when test="${!licenseKey}">
			<td class="stepNumber">&#8594;</td>
			<td>
			<fieldset>
				<legend>License Key (Enterprise Edition only)</legend>
				<p class="instructions">
					If you purchased the Enterprise Edition, enter your license key here to unlock the Enterprise Edition
					features. If you do not have a license key leaving this field blank will install the Community Edition.
				</p>
		
				<html:hidden value="true" property="doLicenseKey"/>
				
				<!-- databaseDialect field -->
			    <label>License Key:</label>
				<html:text styleClass="textbox" size="30" property="licenseKey"/>
				<br/>
			</fieldset>
			</td>
		</c:when>
		<c:otherwise>
			<td class="stepNumber"><img src="<c:out value="${pageContext.request.contextPath}"/>/images/checkmark.gif" alt="completed" /></td>
			<td>
			<fieldset>
				<legend>License Key:</legend>
				<p class="instructions">
					Your license key appears to be installed correctly.
				</p>
				<html:hidden value="false" property="doLicenseKey"/>
			</fieldset>
			</td>
		</c:otherwise>
	</c:choose>
	
		</tr> --%>
		<tr>
	

	<c:choose>
		<c:when test="${!twoWayKeyFileExists}">
			<td class="stepNumber">&#8594;</td>
			<td>
			<fieldset>
				<legend>Encryption Key File</legend>
				<p class="instructions">
					Your store's encryption key does not appear to exist. The installer will attempt to create it.
				</p>
				<html:hidden value="true" property="createTwoWayKey"/>
			</fieldset>
		</c:when>
		<c:otherwise>
			<td class="stepNumber"><img src="<c:out value="${pageContext.request.contextPath}"/>/images/checkmark.gif" alt="completed" /></td>
			<td>
			<fieldset>
				<legend>Encryption Key File</legend>
				<p class="instructions">
					Your store's encryption key appears to exist at <c:out value="${appSettings.twoWayKeyFile}"/>. 
					The installer will leave it untouched. 
					To create a new one, move the current one out of the way.
				</p>
				<html:hidden value="false" property="createTwoWayKey"/>
			</fieldset>
			</td>
		</c:otherwise>
	</c:choose>
	
		</tr>
		<tr>
		
	<!-- database settings heading -->
	<c:choose>
		<c:when test="${!connectedToDatabase}">
			<td class="stepNumber">&#8594;</td>
			<td>
			<fieldset>
				<legend><bean:message key="installer.databaseSettings" bundle="/installer/installer"/></legend>
				<p class="instructions">
					<bean:message key="installer.instructionsBasicDBSettings" bundle="/installer/installer"/>
					The installer will update the /WEB-INF/classes/hibernate.properties file and attempt to make a connection
					using the settings you provide.
				</p>
		
				<html:hidden value="true" property="doDatabaseSettings"/>
				
				<!-- databaseDialect field -->
			    <label><bean:message key="installer.databaseTypeLabel" bundle="/installer/installer"/>:</label>
				<html:select styleClass="selectboxWide" name="basicForm" property="dialect" onchange="setDatabaseParameters(this)">
					<html:option value="org.hibernate.dialect.MySQLInnoDBDialect">MySQL (InnoDB)</html:option>
					<html:option value="org.hibernate.dialect.MySQLMyISAMDialect">MySQL (MyISAM)</html:option>
					<html:option value="org.hibernate.dialect.PostgreSQLDialect">PostgreSQL</html:option>
					<html:option value="org.hibernate.dialect.SQLServerDialect">Microsoft SQL Server</html:option>
					<html:option value="org.hibernate.dialect.OracleDialect">Oracle</html:option>
				</html:select>
				<br/>
			
				<!-- databaseHost field -->
			    <label><bean:message key="installer.databaseHostLabel" bundle="/installer/installer"/>:</label>
				<html:text styleClass="textbox" size="30" property="databaseHost"/>
				<br/>
			
				<!-- databasePort field -->
			    <label><bean:message key="installer.databasePortLabel" bundle="/installer/installer"/>:</label>
				<html:text styleClass="textbox" size="10" property="databasePort"/>
				<br/>
				
				<!-- databaseName field -->
			    <label><bean:message key="installer.databaseNameLabel" bundle="/installer/installer"/>:</label>
				<div class="instructions">
					<html:text styleClass="textbox" size="30" property="databaseName"/>
					<br/>
					<bean:message key="installer.instructionsDatabaseName" bundle="/installer/installer"/>
				</div>
				<br/>
			
				<!-- databaseUserName field -->
			    <label><bean:message key="installer.databaseUserNameLabel" bundle="/installer/installer"/>:</label>
				<html:text styleClass="textbox" property="databaseUserName"/>
				<br/>
				
				<!-- databasePassword field -->
			    <label><bean:message key="installer.databasePasswordLabel" bundle="/installer/installer"/>:</label>
				<html:password styleClass="textbox" property="databasePassword"/>
				<br/>
				
				<!-- enableEnversAuditLogging field -->
			    <label><bean:message key="installer.enableEnversAuditLoggingLabel" bundle="/installer/installer"/>:</label>
				<div class="instructions">
			    	<html:radio styleClass="radiobtn" value="true" property="enableEnversAuditLogging"/><bean:message key="general.yesLabel"/> &nbsp;&nbsp; <html:radio styleClass="radiobtn" value="false" property="enableEnversAuditLogging"/><bean:message key="general.noLabel"/>
					<br/>
					<bean:message key="installer.instructionsEnversAuditLogging" bundle="/installer/installer"/>
				</div>				
			</fieldset>
		</c:when>
		<c:otherwise>
			<td class="stepNumber"><img src="<c:out value="${pageContext.request.contextPath}"/>/images/checkmark.gif" alt="completed" /></td>
			<td>
			<fieldset>
				<legend><bean:message key="installer.databaseSettings" bundle="/installer/installer"/></legend>
				<p class="instructions">
					You appear to be connected successfully to the database. The installer will not attempt
					to update the database settings. To change your connection settings, please modify 
					/WEB-INF/classes/hibernate.properties directly.
				</p>
				<html:hidden value="false" property="doDatabaseSettings"/>
			</fieldset>
			</td>
		</c:otherwise>
	</c:choose>
	
		</tr>
		<tr>

	<c:choose>
		<c:when test="${!databaseObjectsCreated}">
			<td class="stepNumber">&#8594;</td>
			<td>
			<fieldset>
				<legend><bean:message key="installer.stepInitialize" bundle="/installer/installer"/></legend>
				<p class="instructions"><bean:message key="installer.instructionsStoreSettings" bundle="/installer/installer"/></p>
				<html:hidden value="true" property="doDatabaseInitialize"/>
				
				<!-- storeName field -->
		    	<label><bean:message key="installer.storeName" bundle="/installer/installer"/>:</label>
				<div class="instructions">
					<html:text name="basicForm" property="storeName"/>
					<br/>
					<bean:message key="installer.storeNameExpl" bundle="/installer/installer"/>
				</div>
		
				<!-- administratorUserName field -->
		    	<label><bean:message key="installer.administratorUserName" bundle="/installer/installer"/>:</label>
				<div class="instructions">
					<html:text name="basicForm" property="administratorUserName"/>
					<br/>
					<bean:message key="installer.administratorUserNameExpl" bundle="/installer/installer"/>
				</div>
				
				<!-- administratorPassword field -->
		    	<label><bean:message key="installer.administratorPassword" bundle="/installer/installer"/>:</label>
				<div class="instructions">
					<html:password name="basicForm" property="administratorPassword"/>
					<br/>
					<bean:message key="installer.administratorPasswordExpl" bundle="/installer/installer"/>
				</div>
		
		    	<!-- customerURL field -->
		    	<label><bean:message key="installer.customerURL" bundle="/installer/installer"/>:</label>
				<div class="instructions">
					<html:text size="45" styleClass="genericData" property="customerURL"/>
					<br/>
					<bean:message key="installer.customerURLExpl" bundle="/installer/installer"/>
				</div>
		
				<!-- customerSecureURL field -->
		    	<label><bean:message key="installer.customerSecureURL" bundle="/installer/installer"/>:</label>
				<div class="instructions">
					<html:text size="45" styleClass="genericData" property="customerSecureURL"/>
					<br/>
					<bean:message key="installer.customerSecureURLExpl" bundle="/installer/installer"/>
				</div>
		
				<!-- administratorURL field -->
				<label><bean:message key="installer.administratorURL" bundle="/installer/installer"/>:</label>
				<div class="instructions">
					<html:text size="45" styleClass="genericData" property="administratorURL"/>
					<br/>
					<bean:message key="installer.administratorURLExpl" bundle="/installer/installer"/>
				</div>
		
				<!-- test data field -->
			    <label><bean:message key="installer.testDataLabel" bundle="/installer/installer"/>:</label>
				<div class="instructions">
					<html:radio styleClass="radiobtn" value="true" property="insertTestData"/><bean:message key="general.yesLabel"/> &nbsp;&nbsp; <html:radio styleClass="radiobtn" value="false" property="insertTestData"/><bean:message key="general.noLabel"/>
					<br/>
					<bean:message key="installer.instructionsTestData" bundle="/installer/installer"/>
				</div>
		
			</fieldset>
		</c:when>
		<c:otherwise>
			<td class="stepNumber"><img src="<c:out value="${pageContext.request.contextPath}"/>/images/checkmark.gif" alt="completed" /></td>
			<td>
			<fieldset>
				<legend><bean:message key="installer.stepInitialize" bundle="/installer/installer"/></legend>
				<p class="instructions">
					The database appears to have been initialized. The installer will not attempt to initialize it again.
					If you are having problems, it is possible an error occurred and the database is only partially initialized.
					To reinitialize it, delete the current one and create a new, empty database in its place. 
					Or, create a new, empty database and modify /WEB-INF/classes/hibernate.properties 
					to point to it.
				</p>
				<html:hidden value="false" property="doDatabaseInitialize"/>
			</fieldset>
			</td>
		</c:otherwise>
	</c:choose>
	
		</tr>
		<tr>
		
	<!-- log file directory -->
	<c:choose>
		<c:when test="${!logFileDirectoryConfigured}">
			<td class="stepNumber">&#8594;</td>
			<td>
			<fieldset>
				<legend>Log File Directory</legend>
				<p class="instructions">
					Identify a directory on the server for the SoftSlate Commerce log files to reside in.
					The directory should allow <em>writable</em> access for the application server's user.
					By default logs are also written to standard output. You can also modify log4j.properties 
					at any time to configure logging.
				</p>
		
				<html:hidden value="true" property="doLogFileDirectory"/>
				
			    <label>Log File Directory:</label>
				<html:text styleClass="textbox" size="90" property="logFileDirectory"/>
				<br/>
			</fieldset>
			</td>
		</c:when>
		<c:otherwise>
			<td class="stepNumber"><img src="<c:out value="${pageContext.request.contextPath}"/>/images/checkmark.gif" alt="completed" /></td>
			<td>
			<fieldset>
				<legend>Log File Directory:</legend>
				<p class="instructions">
					Your log file directory has been configured.
				</p>
				<html:hidden value="false" property="doLogFileDirectory"/>
			</fieldset>
			</td>
		</c:otherwise>
	</c:choose>
	
		</tr>
		<tr>
			<td class="stepNumber">&#8594;</td>
			<td>
	
	<fieldset>
		<legend><bean:message key="installer.stepLockInstaller" bundle="/installer/installer"/></legend>
		<p class="instructions">
			For security reasons, access to the application is prohibited if the installer is not locked (as of version 2.3.1).
			If all the other installer steps are successful and complete, the installer will lock itself to allow access. 
		</p>
	</fieldset>
			
			</td>
		</tr>

		<!-- Submit Button -->
		<tr>
			<td>&nbsp;</td>
			<td>
				<input type="submit" class="button" name="submittedSettings" value="Run Installer" onmouseover="this.className='button buttonhover'" onmouseout="this.className='button'"/>		
			</td>
		</tr>
	</table>
</html:form>
<!-- End basic.jsp -->
