(function($) {
	$.ss_addressbook = {
			
		addressPage : "",
		popup : null,
		popupMessages : null,
		popupBody : null,

		init : function(page) {
			// Edit props
			$("#addressBookPopup").dialog({
				autoOpen: false,
				modal: true,
				width: 'auto',
				close: $.ss_addressbook.closeEdit
			});
			$.ss_addressbook.popup = $('#addressBookPopup');
			$.ss_addressbook.popupMessages = $('#addressBookPopupMessages');
			$.ss_addressbook.popupBody = $('#addressBookPopupBody');

			// Listeners and things no matter what the page
			$('#addressEditForm').bind("submit", function(event) {
				return false;
			});
			
			$('#addressEditSubmitButton').bind("click", $.ss_addressbook.editAddress);
			$('#addressEditCancelButton').bind("click", $.ss_addressbook.closeEdit);

			if (page == 'checkout') {
				$.ss_addressbook.addressPage = "checkout";
				$('#addressBookDisplay').bind("click", $.ss_addressbook.clickAddress);
				$('#addressBookCheckoutNew input[type="text"]').bind("click", $.ss_addressbook.checkoutNewAddressClicked);
				$('#addressBookBillingDisplay').bind("click", $.ss_addressbook.clickAddress);
				$('#addressBookBillingCheckoutNew').bind("click", $.ss_addressbook.checkoutNewBillingAddressClicked);
				$('#deliveryUseBilling').bind("click", $.ss_addressbook.checkoutDeliveryUseBillingClicked);
				$.ss_addressbook.load("delivery");
				$.ss_addressbook.load("billing");
				// Disable required attribute since a previous address may be selected
				$('#billingAddressFields input').removeAttr('required');
				$('#deliveryAddressFields input').removeAttr('required');
			} else {
				$('#addressBookDisplay').bind("click", $.ss_addressbook.clickAddress);
				$('#shippingAddressesForm').bind("submit", $.ss_addressbook.submitAddress);
				$('#addressBookBillingDisplay').bind("click", $.ss_addressbook.clickAddress);
				$('#addressesForm').bind("submit", $.ss_addressbook.submitAddress);
				$.ss_addressbook.load("delivery");
				$.ss_addressbook.load("billing");
				$.ss_addressbook.addressPage = "account";
			}
			
			// Initialize the delete dialog box
		    $("#deleteDialog").dialog({
		        autoOpen: false,
		        modal: true
		    });
		},

		checkoutNewAddressClicked : function(event) {
			if (!$('#addressBookCheckoutNewContinueRadio').attr('checked')) {
				$('#addressBookCheckoutNewContinueRadio').attr('checked', true);
			} else {
				$('#deliveryUseBilling').attr('checked', false);
			}
		},
		
		checkoutNewBillingAddressClicked : function(event) {
			if (!$('#addressBookCheckoutNewBillingContinueRadio').attr('checked')) {
				$('#addressBookCheckoutNewBillingContinueRadio').attr('checked', true);
			}
		},

		checkoutDeliveryUseBillingClicked : function(event) {
			if ($('#deliveryUseBilling').attr('checked')) {
				$('.addressBookDeliveryOption').attr('checked', false);
			} else {
				$('#addressBookCheckoutNewContinueRadio').attr('checked', true);
			}
		},

		checkoutDeliveryOptionClicked : function(event) {
			if ($('#deliveryUseBilling').attr('checked')) {
				$('#deliveryUseBilling').attr('checked', false);
			}
		},

		clickAddress : function(event) {
			var $clicked = $(event.target);
			
			// Billing or Shipping?
			var addressType = 'delivery';
			if ($clicked.attr('id') == 'addressesFormBillingButton'){
				addressType = 'billing';
			}
			
			if (($clicked.is("button") || $clicked.is("a"))
					&& $clicked.hasClass("deleteAddressBookAddress")) {
				event.preventDefault();
				var currentId = $clicked.attr('id');
				var addressType = 'delivery';
				if ($clicked.hasClass('billing')){
					addressType = 'billing';
				}
				if (currentId) {
					var s = currentId.split("-");
					if (s[1]) {
						// Display a dialog box asking the user to confirm
						$("#deleteDialog").dialog({
							buttons : {
								"Yes" : function() {
									$.ss_addressbook.deleteAddress(s[1],addressType);
								},
								"No" : function() {
									$(this).dialog("close");
								}
							}
						});
						$("#deleteDialog").dialog("open");
					}
				}
			}
			if (($clicked.is("button") || $clicked.is("a"))
					&& $clicked.hasClass("editAddressBookAddress")) {
				event.preventDefault();
				var currentId = $clicked.attr('id');
				if (currentId) {
					var s = currentId.split("-");
					if (s[1]) {
						$.ss_addressbook.loadEdit(s[1]);
					}
				}
			}
		},

		toggleNewAddressFields : function(addressType) {
			var fields = $("#addressBookBillingCheckoutNew input");
			if (addressType == 'delivery') {
				fields = $("#addressBookCheckoutNew input");
			}
			fields.attr('disabled', true);
		},

		centerPopup : function() {
			var winH = $(window).height();
			var winW = $(window).width();
			$.ss_addressbook.popup.css("top", (winH - $.ss_addressbook.popup
					.outerHeight())
					/ 2 + "px");
			$.ss_addressbook.popup.css("left", (winW - $.ss_addressbook.popup
					.outerWidth())
					/ 2 + "px");
		},

		loadEdit : function(id) {
			$("#addressBookPopup").dialog("open");
			// $.ss_addressbook.popup.show();
			$.ss_addressbook.popupMessages.html("&nbsp;");
			$.ss_addressbook.popupBody.html("&nbsp;");
			if (!$.ss_addressbook.popupMessages.hasClass('loadingBar')) {
				$.ss_addressbook.popupMessages.addClass('loadingBar');
			}
			$.ajax( {
				type : "POST",
				url : "AddressEditFormAjax.do",
				data : {
					"customerAddressID" : id
				},
				dataType : "html",
				success : $.ss_addressbook.loadEditSuccess,
				error : $.ss_addressbook.loadEditError
			});
		},

		loadEditSuccess : function(html) {
			$.ss_addressbook.popupMessages.removeClass('loadingBar');
			$.ss_addressbook.checkLogin(html);
			$.ss_addressbook.popupMessages.html("&nbsp;");
			$.ss_addressbook.popupBody.html(html);
			// $.ss_addressbook.centerPopup();
		},

		loadError : function(error) {
			$.ss_addressbook.popupMessages.removeClass('loadingBar');
			$.ss_addressbook.popupBody.html("&nbsp;");
			$.ss_addressbook.popupMessages
					.html("Error communicating, please try again.");
			$.ss_addressbook.centerPopup();
		},

		load : function(type) {
			if (type == 'billing'){
				$('#addressBookBillingDisplay').html('&nbsp;');
				if (!$('#addressBookBillingDisplay').hasClass('loadingBar')) {
					$('#addressBookBillingDisplay').addClass('loadingBar');
				}
			}else{
				$('#addressBookDisplay').html('&nbsp;');
				if (!$('#addressBookDisplay').hasClass('loadingBar')) {
					$('#addressBookDisplay').addClass('loadingBar');
				}
			}
			
			$.ajax( {
				type : "POST",
				url : "LoadAddressBookAjax.do",
				data : {
					"page" : $.ss_addressbook.addressPage,
					"type" : type
				},
				dataType : "html",
				success: function(data){
					$.ss_addressbook.loadSuccess(data,type);
				},
				error: function(error){
					$.ss_addressbook.loadError(error,type);
				}
			});
		},

		fixToSameHeight : function(find) {
			var height = 0;
			$(find).each(
					function() {
						height = ($(this).height() > height) ? $(this).height()
								: height;

					});
			$(find).css('height', height.toString() + 'px');
		},

		loadSuccess : function(html,type) {
			if (type == 'billing'){
				$('#addressBookBillingDisplay').removeClass('loadingBar');
				$.ss_addressbook.checkLogin(html);
				$('#addressBookBillingDisplay').html(html);
				// Fix the LI tags to look better in the html
				$.ss_addressbook.fixToSameHeight('#addressBookBillingDisplay li.address');
			}else{
				$('#addressBookDisplay').removeClass('loadingBar');
				$.ss_addressbook.checkLogin(html);
				$('#addressBookDisplay').html(html);
				// Fix the LI tags to look better in the html
				$.ss_addressbook.fixToSameHeight('#addressBookDisplay li.address');
				$('.addressBookDeliveryOption').bind("click", $.ss_addressbook.checkoutDeliveryOptionClicked);
			}
			
		},

		loadError : function(error,type) {
			if (type == 'billing'){
				$('#addressBookBillingDisplay').removeClass('loadingBar');
				$('#addressBookBillingDisplay').html("Error communicating, please try again.");
			}else{
				$('#addressBookDisplay').removeClass('loadingBar');
				$('#addressBookDisplay').html("Error communicating, please try again.");
			}
			
		},

		closeEdit : function(event) {
			event.preventDefault();
			$.ss_addressbook.popupMessages.html("&nbsp;");
			$.ss_addressbook.popupBody.html("&nbsp;");
			$("#addressBookPopup").dialog("close");
			// $.ss_addressbook.popup.hide();
			$.ss_addressbook.load("delivery");
			$.ss_addressbook.load("billing");
			return false;
		},

		editAddress : function(event) {
			event.preventDefault();
			$('#addressEditForm').fadeOut();
			if (!$.ss_addressbook.popupMessages.hasClass('loadingBar')) {
				$.ss_addressbook.popupMessages.addClass('loadingBar');
			}
			$.ajax( {
				type : "POST",
				url : "EditAddressBookAddressAjax.do",
				data : $('#addressEditForm').serialize(),
				dataType : "html",
				success : $.ss_addressbook.editSuccess,
				error : $.ss_addressbook.editError
			});
		},

		editSuccess : function(html) {
			$.ss_addressbook.popupMessages.removeClass('loadingBar');
			$.ss_addressbook.checkLogin(html);
			$.ss_addressbook.popupMessages.html(html);
			$('#addressEditForm').fadeIn();
			$.ss_addressbook.load("delivery");
			$.ss_addressbook.load("billing");
		},

		editError : function(error) {
			$.ss_addressbook.popupMessages.removeClass('loadingBar');
			$.ss_addressbook.popupMessages
					.html("Error communicating, please try again.");
			$('#addressEditForm').fadeIn();
		},

		submitAddress : function(event) {
			event.preventDefault();
			$form = $(event.target);
			
			var addressType = 'delivery';
			if ($form.attr('id') == 'addressesForm'){
				addressType = 'billing';
			}
			
			if (addressType == 'billing'){
				$('#addressBookBillingDisplay').html('&nbsp;');
				$('#addressesForm').fadeOut();
				if (!$('#addressBookBillingDisplay').hasClass('loadingBar')) {
					$('#addressBookBillingDisplay').addClass('loadingBar');
				}
			}else{
				$('#addressBookDisplay').html('&nbsp;');
				$('#shippingAddressesForm').fadeOut();
				if (!$('#addressBookDisplay').hasClass('loadingBar')) {
					$('#addressBookDisplay').addClass('loadingBar');
				}
			}
			
			$.ajax( {
				type : "POST",
				url : "AddAddressBookAddressAjax.do",
				data : $form.serialize(),
				dataType : "html",
				success: function(data){
					$.ss_addressbook.submitSuccess(data,addressType);
				},
				error: function(error){
					$.ss_addressbook.submitError(error,addressType);
				}
			});
		},

		submitSuccess : function(html, addressType) {
			
			if (addressType == 'billing'){
				$('#addressBookBillingDisplay').removeClass('loadingBar');
				$.ss_addressbook.checkLogin(html);
				$('#addressBookBillingDisplay').html(html);
				$.ss_addressbook.fixToSameHeight('#addressBookBillingDisplay li.address');
				// If no errors, clear the form
				if (html.indexOf('ajaxError') == -1) {
					$.ss_addressbook.clearForm('#addressesForm');
				}
				$('#addressesForm').fadeIn();
			}else{
				$('#addressBookDisplay').removeClass('loadingBar');
				$.ss_addressbook.checkLogin(html);
				$('#addressBookDisplay').html(html);
				$.ss_addressbook.fixToSameHeight('#addressBookDisplay li.address');
				// If no errors, clear the form
				if (html.indexOf('ajaxError') == -1) {
					$.ss_addressbook.clearForm('#shippingAddressesForm');
				}
				$('#shippingAddressesForm').fadeIn();
			}
		},

		submitError : function(error, addressType) {
			if (addressType == 'billing'){
				$('#addressBookBillingDisplay').removeClass('loadingBar');
				$('#addressBookBillingDisplay').html(
						"Error communicating, please try again.");
				$('#addressesForm').fadeIn();
			}else{
				$('#addressBookDisplay').removeClass('loadingBar');
				$('#addressBookDisplay').html(
						"Error communicating, please try again.");
				$('#shippingAddressesForm').fadeIn();
			}
		},

		deleteAddress : function(addressID, addressType) {
			if (addressType != 'billing'){
				addressType = 'delivery';
			}
			
			if (addressType == 'billing'){
				$('#addressBookBillingDisplay').html('&nbsp;');
				if (!$('#addressBookBillingDisplay').hasClass('loadingBar')) {
					$('#addressBookBillingDisplay').addClass('loadingBar');
				}
			}else{
				$('#addressBookDisplay').html('&nbsp;');
				if (!$('#addressBookDisplay').hasClass('loadingBar')) {
					$('#addressBookDisplay').addClass('loadingBar');
				}
			}
			
			$.ajax( {
				type : "POST",
				url : "DeleteAddressBookAddressAjax.do",
				data : {
					"customerAddressID" : addressID,
					"page" : $.ss_addressbook.addressPage,
					"type" : addressType
				},
				dataType : "html",
				success: function(data){
					$.ss_addressbook.deleteSuccess(data,addressType);
				},
				error: function(error){
					$.ss_addressbook.deleteError(error,addressType);
				}
			});
		},

		deleteSuccess : function(html, addressType) {	
			$("#deleteDialog").dialog("close");
			if (addressType == 'billing'){
				$('#addressBookBillingDisplay').removeClass('loadingBar');
				$.ss_addressbook.checkLogin(html);
				$('#addressBookBillingDisplay').html(html);
				$.ss_addressbook.fixToSameHeight('#addressBookBillingDisplay li.address');
			}else{
				$('#addressBookDisplay').removeClass('loadingBar');
				$.ss_addressbook.checkLogin(html);
				$('#addressBookDisplay').html(html);
				$.ss_addressbook.fixToSameHeight('#addressBookDisplay li.address');
			}
		},

		deleteError : function(error, addressType) {
			$("#deleteDialog").dialog("close");
			if (addressType == 'billing'){
				$('#addressBookBillingDisplay').removeClass('loadingBar');
				$('#addressBookBillingDisplay').html("Error communicating, please try again.");
			}else{
				$('#addressBookDisplay').removeClass('loadingBar');
				$('#addressBookDisplay').html("Error communicating, please try again.");
			}
			
		},

		checkLogin : function(html) {
			if (html.indexOf("loginLayout") != -1) {
				document.location = "Account.do";
			} else {
				return;
			}
		},

		clearForm : function(form) {
			$(form).find(':input').each(function() {
				switch (this.type) {
				case 'password':
				case 'select-multiple':
				case 'select-one':
				case 'text':
				case 'textarea':
					$(this).val('');
					break;
				case 'checkbox':
				case 'radio':
					this.checked = false;
				}
			});
		}
	};
})(jQuery);
