INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('dataObjectsVersion','Data Objects Version','The version represented by current state of the database objects in the database. Normally, this setting should not be changed manually. It is updated automatically by running the upgrade process.','ADVANCEDSYSTEM','smallValue',NULL,'3.5.1',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('possibleFields','Possible Address Fields','A comma-separated list of all the possible address fields available to be populated in the system. <b>Unless you are adding fields through custom development, this value should not be changed.</b> To adjust which fields are displayed to users, use the <a href="SettingsAddress.do">Address Fields</a> screen.','ADVANCEDSYSTEM','textValue',NULL,NULL,NULL,'firstName,lastName,organization,address1,address2,city,state,other,postalCode,country,phone1,phone2,email1,email2,extra1,extra2,extra3,extra4,extra5,notes');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('billingPrompt','Prompted Billing Address Fields','A comma-separated list of the address fields that users will be prompted for when filling in a billing address.','ADDRESS','textValue',NULL,NULL,NULL,'firstName,lastName,organization,address1,address2,city,state,other,postalCode,country,phone1,email1');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('deliveryPrompt','Prompted Delivery Address Fields','A comma-separated list of the address fields that users will be prompted for when filling in a delivery address.','ADDRESS','textValue',NULL,NULL,NULL,'firstName,lastName,organization,address1,address2,city,state,other,postalCode,country,phone1,email1');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('billingRequired','Required Billing Address Fields','A comma-separated list of the address fields that users are required to provide when filling in a billing address.','ADDRESS','textValue',NULL,NULL,NULL,'firstName,lastName,address1,city,state,postalCode,country,email1');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('deliveryRequired','Required Delivery Address Fields','A comma-separated list of the address fields that users are required to provide when filling in a delivery address.','ADDRESS','textValue',NULL,NULL,NULL,'firstName,lastName,address1,city,state,postalCode,country,email1');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('possibleValidatedFields','Possible Validated Address Fields','A comma-separated list of the address fields that can have their formats validated by the system.','ADDRESS','textValue',NULL,NULL,NULL,'state,postalCode,email1,email2,phone1,phone2');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('billingValidated','Validated Billing Address Fields','A comma-separated list of the address fields whose formats are validated when provided in a billing address.','ADDRESS','textValue',NULL,NULL,NULL,'state,postalCode,phone1,phone2,email1,email2');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('deliveryValidated','Validated Delivery Address Fields','A comma-separated list of the address fields whose formats are validated when provided in a delivery address.','ADDRESS','textValue',NULL,NULL,NULL,'state,postalCode,phone1,phone2,email1,email2');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('customerURL','Base Customer URL','The absolute URL path to the base directory of the application for customers.','STOREURLS','mediumValue',NULL,NULL,'http://localhost:8080/softslate',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('customerSecureURL','Base Secure Customer URL','The secure, absolute URL path to the base directory of the application for customers. It is possible to use a URL beginning with http for this setting, such as during testing an development. For live stores capturing personal information, a security certificate should be installed on the host server, and this setting should be changed to begin with https.','STOREURLS','mediumValue',NULL,NULL,'http://localhost:8080/softslate',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('administratorURL','Administrator URL','The absolute URL path to the base directory of the application for administrators. For live stores, a security certificate should be installed and this setting should begin with https.','STOREURLS','mediumValue',NULL,NULL,'http://localhost:8080/softslate/administrator',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('currencyCode','Store Currency Code','The ISO 4217 currency code for the currency the store is selling products with.','ADVANCEDSYSTEM','smallValue',NULL,'USD',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('orderNumberFloor','Order Number Floor','As each order is completed, it is assigned a new sequential order number, which is shown on the invoice and within the order confirmation emails. This setting is added to the value of sscOrderNumber.orderNumberID to determine the next order number of the store.','ADVANCEDSYSTEM','integerValue',1000,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('numberFailedLoginsBeforeLockingOutCustomer','Number of Failed Logins Before Locking Out','The number of failed attempts for a Customer to login before being locked out. Set to 0 to never lock out.','CUSTOMERSECURITY','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('lockoutDurationInMinutesCustomer','Lock Out Duration in Minutes','The number of minutes an Customer must wait to login after being locked out.','CUSTOMERSECURITY','integerValue',30,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('passwordExpirationInDaysCustomer','Password Expiration in Days','The number of days a new Customer password will be valid before it is expired and must be changed. Use 0 to never expire passwords.','CUSTOMERSECURITY','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('numberOfPreviousPasswordsToCheckCustomer','Number of Previous Passwords To Check','The number of previous passwords to check against a new password. Set to 0 to never check if a new password is the same as a previous password.','CUSTOMERSECURITY','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('passwordRequiresLetterAndNumberCustomer','Password Require One Letter and Number?','If yes, new Customer passwords must contain at least one letter and one number.','CUSTOMERSECURITY','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('minimumPasswordLength','Minimum Password Length','The minimum length in characters that the system allows for new customer account passwords.','CUSTOMERACCOUNT,CUSTOMERSECURITY','integerValue',4,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('requireEmailActivation','Require Email Activation for New Registrations','If set to yes, when registering a new account, the customer will have to follow an emailed link to set the password and complete the registration. Note: the Keep User Name and Email in Sync setting must be set to yes on on the Customers -> Customer Account Settings screen, for this feature to work.','CUSTOMERSECURITY','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('keepUserNameAndEmailInSync','Keep User Name and Email in Sync','If true, the system will use the billing email address as the user name for all customers.','CUSTOMERACCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('forceLogin','Force Login on Orders','If true, a user must be logged in as a customer before being able to place an order.','CUSTOMERACCOUNT,CHECKOUT','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('inviteLoginBeforeCheckout','Invite Login Before Checkout','If true, the first screen of the checkout process will invite the user to log in, if he has not already.','CUSTOMERACCOUNT,CHECKOUT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useAjaxOnePageCheckout','Use Ajax One-Page Checkout Form?','If true, the checkout process will feature a single screen with address, shipping, and payment form fields, rather than separate screens. Unlike the Combo Screen however, Ajax is used to submit the address information before shipping options are displayed. This allows you to use this form even if you use UPS, FedEx, or USPS, where the delivery address must be submitted before shipping options can be displayed. (Overrides Use Combined Address and Shipping setting and Use Combo Layout setting.)','CHECKOUT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('statesWhereShippingIsTaxable','States Where Shipping Is Taxable','List of US states or Canadian provinces where shipping charges should be taxed.','SHIPPING,TAXES','textValue',0,NULL,NULL,'AR,GA,KY,LA,MI,MN,MS,NJ,NM,NC,PA,SC,TX,WA,WI');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('shippingRequired','Is a Shipping Selection Required?','If true, the customer must select a valid shipping option before placing an order.','SHIPPING','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('paymentRequired','Is Payment Information Required?','If true, the customer must enter valid payment information before placing an order.','PAYMENTS','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('areTaxRatesCumulative','Are Tax Rates Cumulative?','If true, each matching tax rate will be applied cumulatively; if false, only the most specific matching tax rate will be applied.','TAXES','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('securityCodeRequired','Is a Security Code Required for Credit Cards?','If true, customers must submit a security code as part of their credit card payment submission.','PAYMENTS','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useCheckoutCombo','Use Combined Address, Shipping and Payment Screen in Checkout?','If true, the checkout process will feature a single screen with address, shipping, and payment form fields, rather than separate screens. (Overrides Use Combined Address and Shipping setting.) <strong>Warning: This option cannot be used with some payment methods such as Authorize.net DPM, CRE Secure, and the Accept.js option under Authorize.net AIM.</strong>','CHECKOUT','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('combineCheckoutShippingAddresses','Use Combined Address and Shipping Screen in Checkout?','If true, the checkout process will feature a single screen with address form fields and shipping options, rather than separate address and shipping screens.','CHECKOUT','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displayCheckoutConfirm','Display Confirm Screen Before End of Checkout?','If true, customers will be shown a confirmation screen at the end of the checkout process, and must confirm their order before it is processed.','CHECKOUT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('catalogMode','Catalog Mode','If true, the store will not allow orders, logins, or new customer accounts, and buttons and links related to orders will be suppressed.','CHECKOUT','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeLogo','Store Logo','The URL path (relative or absolute) to the logo image for the store appearing in the header. This logo will appear in the header of all store pages. If this setting is left blank, the store name will be displayed instead.','STORELOGO','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('fontFamily','Font Family','The font family in effect for the store. Select Other and leave blank to use the font family defined in the CSS theme.','GENERALDISPLAY','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('fontSize','Font Size','The font size in effect for the store. Use a valid CSS format such as <strong>12pt</strong>, <strong>14px</strong>, or <strong>90%</strong>. Leave blank to use the font size defined in the CSS theme, which is typically <strong>78%</strong>.','GENERALDISPLAY','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('html5CssTheme','HTML5 CSS Theme','The HTML5 Theme in effect for the store (default-html5 layout only).', 'HTML5THEMES','smallValue',NULL,'css',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('cssTheme','CSS Theme','The theme in effect for the store. Corresponds to a subdirectory under /css containing the CSS styles. The base theme is always included before the selected theme, and the custom theme is included after. (default-xhtml layout only).','THEMES','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('mainColor','Main Color','The color used in prominent places within the layout of the store, including the navigation bar, and the background of the widgets. Leave blank to use the color defined in the CSS theme.','GENERALDISPLAY','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('headingColor','Heading Color','The color used for the text headings on each screen. Leave blank to use the color defined in the CSS theme.','GENERALDISPLAY','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('buttonColor','Button Color','The color used for the background of all buttons. Leave blank to use the color defined in the CSS theme.','GENERALDISPLAY','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('navBarOptions','Navigation Options','A comma-separated list of the possible links available in the system for display in the navigation bar.','HEADERANDSIDEPANEL','textValue',NULL,NULL,NULL,'home,products,manufacturers,contact,search,account,cart,checkout');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('navBarLinks','Navigation Bar Links','The links currently displayed in the navigation bar.','HEADERANDSIDEPANEL','textValue',NULL,NULL,NULL,'products,manufacturers,contact,account,cart,checkout');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('footerLinks','Footer Links','The links currently displayed across the bottom of all pages in the footer.','HEADERANDSIDEPANEL','textValue',NULL,NULL,NULL,'home,products,manufacturers,contact,account,cart,checkout');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('headerCategoriesAndPages','Categories and Content Pages in Header','A comma-separated list of category codes (or content page codes). The categories and content pages identified will appear as links in the header on all pages of the store.','HEADERANDSIDEPANEL','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('footerCategoriesAndPages','Categories and Content Pages in Footer','A comma-separated list of category codes (or content page codes). The categories and content pages identified will appear as links in the footer on all pages of the store.','HEADERANDSIDEPANEL','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('paginationStyle','Pagination Style','The style that the paging controls on product list pages is displayed with.','PRODUCTLISTDISPLAY','smallValue',NULL,'nextAndPrevious',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displayAddToCartOnListPages','Display Add to Cart on List Pages?','If true, search results, category pages, and other product lists will prompt customers to add multiple items to their cart at once.','PRODUCTLISTDISPLAY','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('productListPageSize','Product List Page Size','The number of products to display per page of the product list.','PRODUCTLISTDISPLAY','integerValue',12,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('categoryPageSize','Category Page Size','The number of products to display per page of a category page.','PRODUCTLISTDISPLAY','integerValue',12,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('manufacturerPageSize','Manufacturer Page Size','The number of products to display per page of a manufacturer page.','PRODUCTLISTDISPLAY','integerValue',12,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('searchResultsPageSize','Search Results Page Size','The number of products to display per page of search results.','PRODUCTLISTDISPLAY','integerValue',12,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('orderHistoryPageSize','Order History Page Size','The number of orders to display per page on the account order history screen.','CUSTOMERACCOUNT','integerValue',10,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('baseLayout','Base Layout','The layout directory used for any JSP templates that do not exist in the current layout for the user, nor the Common Layout. The valid values are default (a legacy set of templates), default-xhtml, and default-html5.','ADVANCEDDISPLAY','smallValue',NULL,'default-html5',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('commonLayout','Common Layout','The layout directory used for any JSP templates that do not exist in the current layout for the user. (Layout names correspond to directory names under the /WEB-INF/layouts directory.) If necessary, set this to a directory used to store templates that are common to mutiple other layouts, to prevent duplication of customizations.','ADVANCEDDISPLAY','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('defaultLayout','Default Layout','The layout given to users by default, if the layout is not specified on the URL with the layout parameter. (Layout names correspond to directory names under the /WEB-INF/layouts directory.)','ADVANCEDDISPLAY','smallValue',NULL,'custom',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeName','Store Name','The name of the store, which appears in the title bar of all store pages, as well as invoices. The store name also appears in the header of all store pages, unless a logo has been defined through the <a href="SettingsStoreLogo.do">Store Logo Upload form</a>.','STOREINFO','smallValue',NULL,'My Store',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeAddress1','Store Address 1','The first line of the street address of the store, as appears on its invoices and elsewhere.','STOREINFO','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeAddress2','Store Address 2','The second line of the street address of the store, as appears on its invoices and elsewhere.','STOREINFO','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeCity','Store City','The city of the store, as appears on its invoices and elsewhere.','STOREINFO','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeStateOrProvince','Store State or Province','The state or province of the store, as appears on its invoices and elsewhere.','STOREINFO','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storePostalCode','Store Postal Code','The postal code of the store, as appears on its invoices and elsewhere.','STOREINFO','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeCountry','Store Country','The country of the store, as appears on its invoices and elsewhere.','STOREINFO','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeEmailAddress','Store Email Address','The email address used by the store, as appears on its invoices and elsewhere. This email is also used as the From address for all of the outgoing emails the store produces, including the lost password emails and order confirmation emails. <em>This setting must be defined and valid in order for outgoing emails to go out.</em>','STOREINFO,EMAIL','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storePhone','Store Phone','The phone number of the store, as appears on its invoices and elsewhere.','STOREINFO','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeFax','Store Fax','The fax number of the store, as appears on its invoices and elsewhere.','STOREINFO','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeSMTPServer','SMTP Server','The domain name or IP address of the SMTP server for the store, to allow it to send emails. An SMTP server is a server that is configured to send out emails. In many cases, the server the application is installed on, identified by the IP address "127.0.0.1", may be used. If this does not work, your host provider should be able to assist you with this setting.','EMAIL','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeSMTPUsername','SMTP Server User Name','Username for SMTP authentication. Not all SMTP servers require a user name and password. Leave this field blank if no authentication is required.','EMAIL','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeSMTPPassword','SMTP Server Password','Password for SMTP authentication. Not all SMTP servers require a user name and password. Leave this field blank if no authentication is required.','EMAIL','encryptedValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeSMTPPort','SMTP Server Port','The Port number used to connect to the SMTP server. (Used only with SMTP servers requiring a user name and password. If a user name and passord is not defined, port 25 is used.)','EMAIL','integerValue',25,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useLegacyJSPOrderEmailTemplates','Use Legacy JSP Order Email Templates?','Use the legacy JSP order email template, orderEmails.jsp to send the order confirmation and order notification emails when an order is completed by a customer. If set to no, the system will use the Velocity Templates defined under Emails -> Templates instead. Must be set to false for order emails placed by the API to be sent.','EMAILS', 'booleanValue', '0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('invoiceEmailCC','Invoice Email Copy','A comma-separated list of email addresses that will be copied on the invoice email sent to the customer.','EMAIL','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('invoiceEmailBCC','Invoice Email Blind Copy','A comma-separated list of email addresses that will be blind copied on the invoice email sent to the customer.','EMAIL','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('notificationEmailTO','Notification Email To','A comma-separated list of email addresses that will be sent the notification email sent to the store.','EMAIL','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('notificationEmailCC','Notification Email Copy','A comma-separated list of email addresses that will be copied on the notification email sent to the store.','EMAIL','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('notificationEmailBCC','Notification Email Blind Copy','A comma-separated list of email addresses that will be blind copied on the notification email sent to the store.','EMAIL','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('paymentEncryptionType','Encryption for Payment Information','The type of encryption used by the system for payment information.','ENCRYPTION','smallValue',NULL,'twoWay',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('administratorEncryptionType','Encryption for Administrator Passwords','The type of encryption used by the system for administrator passwords.','ENCRYPTION','smallValue',NULL,'oneWay',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('customerEncryptionType','Encryption for Customer Passwords','The type of encryption used by the system for customer account passwords.','ENCRYPTION','smallValue',NULL,'oneWay',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('oneWayEncryptionAlgorithm','One-Way Encryption Algorithm','The algorithm used by the system for one-way encryption.','ENCRYPTION','smallValue',NULL,'sha256',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('numberFailedLoginsBeforeLockingOut','Number of Failed Logins Before Locking Out','The number of failed attempts for an Administrator to login before being locked out. Set to 0 to never lock out. (PCI 3.2: 6)','ADMINISTRATOR','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('lockoutDurationInMinutes','Lock Out Duration in Minutes','The number of minutes an Administrator must wait to login after being locked out. (PCI 3.2: 30).','ADMINISTRATOR','integerValue',30,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('passwordExpirationInDays','Password Expiration in Days','The number of days a new Administrator password will be valid before it is expired and must be changed. Use 0 to never expire passwords. (PCI 3.2: 90).','ADMINISTRATOR','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('numberOfPreviousPasswordsToCheck','Number of Previous Passwords To Check','The number of previous passwords to check against a new password. Set to 0 to never check if a new password is the same as a previous password. (PCI 3.2: 4).','ADMINISTRATOR','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('minimumAdministratorPasswordLength','Minimum Password Length','The minimum length any new Administrator password must be. (PCI 3.2: 7).','ADMINISTRATOR','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('passwordRequiresLetterAndNumber','Password Require One Letter and Number?','If yes, new Administrator passwords must contain at least one letter and one number. (PCI 3.2: yes).','ADMINISTRATOR','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useSEOLinks','Use SEO Links','If true, the system will write links to the Welcome Screen, Page Screens, and Product and Category Screens in a search-engine friendly format, using the following settings.','SEO','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoURLMarker','SEO URL Marker','The marker used as a subdirectory when generating search-engine friendly links (e.g. "do" in "/context/do/page/about"). <em>Patterns matching this value must be mapped to the application server hosting the store.</em> This setting may also be blank, in which case each of the markers defined below must be mapped to the application server hosting the store.','SEO','smallValue',NULL,'do',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoWelcomeMarker','SEO Welcome Marker','The marker used as a subdirectory when generating the search-engine friendly link to the Welcome Screen (e.g. "welcome" in "/context/do/welcome").','SEO','smallValue',NULL,'welcome',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoPageMarker','SEO Page Marker','The marker used as a subdirectory when generating search-engine friendly links to Page Screens (e.g. "page" in "/context/do/page/about").','SEO','smallValue',NULL,'page',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoCategoryMarker','SEO Category Marker','The marker used as a subdirectory when generating the search-engine friendly link to a Category Screen (e.g. the "category" in "/context/do/category/widgets" where widgets is the category code).','SEO','smallValue',NULL,'category',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoContentMarker','SEO Content Marker','The marker used as a subdirectory when generating the search-engine friendly link to a Content Page Screen (e.g. the "content" in "/context/do/content/pagename" where pagename is the category code of the content page).','SEO','smallValue',NULL,'content',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoProductMarker','SEO Product Marker','The marker used as a subdirectory when generating the search-engine friendly link to a Product Screen (e.g. the "product" in "/context/do/product/widget" where widget is the product code).','SEO','smallValue',NULL,'product',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoManufacturerMarker','SEO Manufacturer Marker','The marker used as a subdirectory when generating the search-engine friendly link to a Manufacturer Screen (e.g. the "manufacturer" in "/context/do/manufacturer/acme" where acme is the manufacturer code).','SEO','smallValue',NULL,'manufacturer',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoProductListMarker','SEO Product List Marker','The marker used as a subdirectory when generating the search-engine friendly link to the Product List Screen (e.g. the \"productlist\" in \"/context/do/productlist\").','SEO','smallValue',NULL,'productlist',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoSuffix','SEO Suffix','A suffix appended to the end of all search-engine friendly URLs (e.g. ".html" in "/context/do/product/widget.html").','SEO','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoDefaultKeywords','Default Keywords','The default keywords to place in the meta/keywords tag for the store. Product and category pages may override this setting through the keywords property.','SEO','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoDefaultDescription','Default Description','The default description to place in the meta/description tag for the store. Product pages may override this setting through the short description property; category pages may override this setting through the description property.','SEO','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('trackInventory','Track Inventory','If true, inventory features will be enabled for the store. If false, they will all be disabled. <b>This setting must be set to yes for any of the inventory features to work.</b>','INVENTORY','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('denyPurchaseWhenOOS','Deny Purchase When Out of Stock','Prevents customers from adding a SKU to their cart when it goes out of stock. The product will still be displayed in the store, but no Add to Cart button will appear. (This setting may be overridden for a particular product in the product settings.)','INVENTORY','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('deactivateWhenOOS','Deactivate Products When Out of Stock','Sets the active flag for a product to false when a SKU associated with it goes out of stock. When the product is set to be inactive, it will no longer be displayed anywhere in the store. (This setting may be overridden for a particular product in the product settings.)','INVENTORY','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('decrementBehavior','Decrement Behavior','Determines when to decrement the inventory level for a SKU. <b>If set to decrement upon order completion,</b> if two shoppers add the same item to the cart and both shoppers then complete their orders, it is possible for inventory to go below the out of stock level. <b>If set to decrement upon adding to the cart,</b> the inventory level will decrease as soon as the item is added to cart so a second shopper would not be able to add it. However, if the first user does not complete the order, the inventory must be reclaimed by deleting incomplete orders through the Maintenance and Upgrades -> Incomplete Orders screen. (This setting may be overridden for a particular product in the product settings.)','INVENTORY','smallValue',NULL,'onOrderCompletion',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('oosAmount','Out of Stock Level','Inventory level when a SKU is considered out of stock (normally 0). (This setting may be overridden for a particular product in the product settings.)','INVENTORY','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('lowAmount','Low Stock Level','Inventory level when a SKU is considered as having low stock, which may trigger a low stock email. (This setting may be overridden for a particular product in the product settings.)','INVENTORY','integerValue',10,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('sendLowStockEmails','Send Low Stock Notifications','If true, a notification email will be sent whenever a SKU reaches its low stock level. (This setting may be overridden for a particular product in the product settings.)','INVENTORY','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('lowStockEmailTO','Low Stock Email To','A comma-separated list of email addresses that will be sent the low stock emails. (This setting may be overridden for a particular product in the product settings.)','INVENTORY','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('lowStockEmailSubject','Low Stock Email Subject','The subject of the low stock emails generated by the store. (This setting may be overridden for a particular product in the product settings.)','INVENTORY','mediumValue',NULL,NULL,'Low Stock Notice for Product Code %%PRODUCT_CODE%%',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('lowStockEmailTemplate','Low Stock Email Text Template','A string template used to construct the text part of the low stock email. (This setting may be overridden for a particular product in the product settings.)','INVENTORY','textValue',NULL,NULL,NULL,'The following SKU has reached its low stock level:\r\n\r\nProduct code: %%PRODUCT_CODE%%\r\nSKU Number: %%SKU_NUMBER%%\r\nSKU ID: %%SKU_ID%%\r\nSKU Notes: %%SKU_NOTES%%\r\nLow stock level: %%LOW_STOCK_LEVEL%%\r\nPrevious level: %%PREVIOUS_LEVEL%%\r\nCurrent level: %%INVENTORY_LEVEL%%\r\n');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('builtInCategories','Built-In Categories','A comma-separated list of category codes corresponding to categories whose products and other data will be read into the application upon start up and available to all store pages. For the default-html5 layout, a short list of the products under each of these categories is displayed on the Welcome page.','HEADERANDSIDEPANEL','textValue',NULL,NULL,NULL,'_features,_favorites');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('builtInCategoryProductCount','Number of Built-in Category Products to Display','If more then zero, the Welcome page will list this many products from each of the built-in categories. Set at 0 to suppress the display of the built-in categories.','HEADERANDSIDEPANEL','integerValue',3,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('endSessionOnOrderCompletion','End Session on Order Completion?','If true, customers will be logged out and their session cleared when completing an order.','CHECKOUT,SESSION','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('applyDiscounts','Apply Discounts?','If true, active and applicable discounts will be applied. This is a global switch to turn discounting on and off. <b>This setting must be set to yes for any of the discount features to work.</b>','DISCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('applyDiscountsToTaxableSubtotal','Apply Discounts To Taxable Subtotal?','If true, global discounts will be subtracted from the taxable subtotal in addition to the regular subtotal.','DISCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('showCouponFormOnCartScreen','Show Coupon Form on Cart Screen?','If true, the form to enter coupons will appear on the Cart screen (if the Apply Discounts setting is also set to true).','DISCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('showCouponFormAtCheckout','Show Coupon Form at Checkout?','If true, the form to enter coupons will appear during checkout above the addresses form (if the Apply Discounts setting is also set to true).','DISCOUNT','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('allowStackedCoupons','Allow Stacked Coupons?','If true, customers will be allowed to redeem multiple coupons for each order. If false, only the last coupon entered will be allowed for the order. Other discounts that are not coupons will always be allowed.','DISCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('keepOrdersInSync','Keep Order Fields in Sync?','If true, updates in the Administrator will synchronize the following fields: Product.productOrder with ProductCategory.productCategoryOrder and RelatedProduct.relatedProductOrder, and Attribute.attributeOrder with ProductAttribute.productAttributeOrder.','ADVANCEDSYSTEM','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('allowSavedCarts','Allow Customers To Save Carts?','If true, logged in customers will see the option to save a cart in their account.','CUSTOMERACCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('refreshSavedCarts','Refresh Carts When Customers Pick Up?','If true, when customers pick up a saved cart, the system will reprocess the items to ensure the cart is still valid.','CUSTOMERACCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('savedCartDays','Number of Days to Save Carts','The number of days to save a cart before customers can no longer retrieve them. Zero indicates no limit.','CUSTOMERACCOUNT','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('allowReorders','Allow Customers To Reorder?','If true, logged in customers will see the option to reorder a previously placed order from their order history (payment info must always be reentered).','CUSTOMERACCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('refreshReorders','Refresh Carts When Customers Reorder?','If true, when customers reorder a previously placed order, the system will reprocess the items to ensure the items are still valid.','CUSTOMERACCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('reorderDays','Number of Days to Allow Reorders','The number of days back a previously placed order may be reordered. Zero indicates no limit.','CUSTOMERACCOUNT','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('attributeValueMaxLength','Attribute Value Max Length','The maximum number of characters allowed for customer-inputted attribute values. If an attribute is defined with a type of compactInput or extendedInput, it will prompt customers to enter text for the product as they add it to the cart. This setting provides a cap on how much text they can submit to the system.','ADVANCEDSYSTEM','integerValue',250,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('clearCartOnLogout','Empty Cart When Customer Logs Out?','If true, when a customer logs out, all items in the cart will be removed.','SESSION','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('imagePathURL','URL Path to Images','The virtual URL path to the directory to store images that are uploaded from the product and category administrator forms, as well as the Store Logo Upload form. It should end with a slash. Note: if the Image System Path is blank, the application context directory will be prepended to this value.','ADVANCEDSYSTEM','mediumValue',NULL,NULL,'/images/store/',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('imageSystemPath','System Path to Images on Server','The full path to the directory on the system to store images that are uploaded from the product and category administrator forms, as well as the Store Logo Upload form. It should end in a slash. Leave blank to derive the system path from the URL path.','ADVANCEDSYSTEM','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchOn','Use Advanced Search for Searches','If set to yes, the search form in the store will use Lucene to perform searches.','LUCENE','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchCategory','Use Advanced Search within Categories','If set to yes, on category pages, the products will be displayed using the Lucene advanced search engine.','LUCENE','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchManufacturer','Use Advanced Search within Manufacturers','If set to yes, on manufacturer pages, the products will be displayed using the Lucene advanced search engine.','LUCENE','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchProductList','Use Advanced Search for the Product List','If set to yes, on the product list page, the products will be displayed using the Lucene advanced search engine.','LUCENE','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchPriceSort','Allow Advanced Search Sorting','Allows the user to sort the products by price, name, etc., using Lucene.','LUCENE','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchIncludeAllDocuments','Include All Documents in Search Results','Include all indexed documents including categories and manufacturers in search results? If set to no the results will only contain products.','LUCENE', 'booleanValue','1',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchIndexAttributes','Add Attributes and Options to Index','If set to yes, text fields from each attribute and option under a product will be included in the index and will cause a match on a product search.','LUCENE','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchIncludeSubcategories','Include Subcategory Products','If set to yes, on category pages, all the products associated with subcategories of the category will be displayed, in addition to those associated with the category itself.','LUCENE','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useSEOCodeForProductURLs','Use SEO Code for Product URLs','If true, the system will use the value of the SEO Code field of each product when writing links to the product pages. If not, or if the SEO Code field is blank, it will use the Code field.','SEO','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('maxRecordsProcessed','Max Records Processed','For certain batch functions such as Lucene reindexing and product imports, the system will process only this many records at once. A high number means more memory and less CPU will be needed.','ADVANCEDSYSTEM','integerValue',1000,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, type, valuetype, integervalue, smallvalue, mediumvalue, textvalue, description) VALUES ('defaultAdminItemsPerPage', 'Default Administrator Control Screen Items Per Page', 'ADVANCEDSYSTEM', 'integerValue', 50, NULL, NULL, NULL, 'On Administrator control screens, the default number of items displayed.');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('automaticallySaveLastCart','Automatically Save Last Cart','If true, the system will automatically save the last cart for each user and restore it the next time he visits the site. Places a persistent cookie to record the saved cart token.','CUSTOMERACCOUNT,SESSION','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('allowCustomerAutoLogins','Allow Auto Logins for Customers','If true, customers will see a Remember Me? prompt upon logging in, which will store a persistent cookie and allow them to automatically login with future visits.','CUSTOMERACCOUNT,SESSION','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('autoLoginDays','Auto Login Days','The number of days the customer will be automatically logged in for, after which a new login will be required. Zero indicates no limit.','CUSTOMERACCOUNT','integerValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('mergeFactor','Lucene Merge Factor','The number of documents to store in memory before writing to the index. A higher number means more memory and less CPU used during reindexing.','ADVANCEDSYSTEM','integerValue',10,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('seoIncludeCategoryCodes','Include Category Codes in Product URLs','If true, SEO product URLs will include the code of the category the user came from in the generated URLs. Search engines may penalize your product pages if they can be reached from more than one unique URL, so if your products are assigned to more than one category you should consider setting this to no.','SEO','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('strikeThruPrices','Strike Through Product Prices','If true and if a discount applies to a product, the regular price will be crossed out and the discounted price displayed next to it.','DISCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('initializeCategoryTreeAndMap','Initialize Category Tree And Category Map','If true, the category tree and category map will be loaded into memory when the application starts. Consider setting to no if your store has a large number of categories, for faster start ups. It must be set to yes for the category tree to display.','HEADERANDSIDEPANEL','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displayCategoryTree','Display Category Tree','If true, the category tree will be displayed under a Browse link in the main nav bar (default-html5) or in the side panel (default-xhtml). Only applies if the category tree and map are loaded.','HEADERANDSIDEPANEL','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('characterEncoding','Character Encoding','The character encoding the system will use when outputting HTML responses. Leave blank to use the server default.','ADVANCEDSYSTEM','smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displayCategoriesOnWelcomePage','Display Categories on Welcome Screen','If true, a list of the top-level categories of the store will be displayed in the body of the Welcome page.','HEADERANDSIDEPANEL','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('maxWelcomePageCarouselCategories','Max Welcome Page Carousel Items','The number of items displayed in a carousel of the large images of the top-level categories of the store on the welcome page. Set to 0 to not display a carousel. (default-html5 layout only.)','HEADERANDSIDEPANEL','integerValue',10,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('upsellRelatedProductsOnCartPage','Upsell Related Products on Cart Page','If true, the related products for each product that is added to the cart will appear on the cart page after the product is added.','CHECKOUT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('insertGenericTracking','Insert Generic Tracking Code','If true, store pages will insert the generic tracking code below for tracking page hits.','TRACKING','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('genericTrackingNormal','Normal Generic Tracking Code','The generic tracking code to insert on all pages of the store other than the order confirmation page.','TRACKING','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('genericTrackingOrder','Order Generic Tracking Code','The generic tracking code to insert on the order confirmation page.','TRACKING','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('miniManufacturersCount','Number of Manufacturuers to Display','If more than zero, the Welcome page (default-html5) or side panel (default-xhtml) will list this many manufacturers. Set at 0 to suppress the display of the manufacturers. (Note, you may also display a link to view a screen with all manufacturers using the Navigation Bar Options setting.)','HEADERANDSIDEPANEL','integerValue',3,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('currentCategoryProductCount','Number of Products from the Most Recently Visited Category to Display','If more than zero, the Welcome page (default-html5) or side panel (default-xhtml) will list this many products from the most recently visited category. Set at 0 to suppress the display of the most recently visited category.','HEADERANDSIDEPANEL','integerValue',3,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('rejectNonSecureAdminRequests','Reject Non-Secure Administrator Requests','If true, any request made to the Administrator that does not employ SSL (https URLs) will be rejected.','SESSION','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('miniCartItemCount','Number of Items to Display in the Mini Cart','If more than zero, the Welcome page (default-html5) or side panel (default-xhtml) will list this many items in the mini cart. Set at 0 to suppress the display of the mini cart.','HEADERANDSIDEPANEL','integerValue',3,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displayPanel','Display Side Panel','If true, a side panel will be displayed with the below options. Setting this to no disables the display of the search form, mini cart, and other below options. (default-xhtml layout only.)','HEADERANDSIDEPANEL','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displaySearchForm','Display Search Form','If true, the product search form will display in the header (default-html5) or side panel (default-xhtml), on all pages other than checkout and customer account pages. By default the form triggers a regular database search of products, unless Advanced Search has been enabled on the Advanced Search Settings screen.','HEADERANDSIDEPANEL','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('productListDisplayFormat','Product List Display Format','Defines if the products on product list pages such as category pages should be displayed in column or row format. (default-xhtml only.)','PRODUCTLISTDISPLAY','smallValue',NULL,'columns',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('productListNumberOfColumns','Number of Columns on Product List Pages','The number of columns to display products in on product list pages. For the default-html5 layout, this is the maximum number of columns displayed for the widest screens. For default-html5 valid values are 1, 2, 3, 4, 6, and 12.','PRODUCTLISTDISPLAY','integerValue',4,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeDiscountsCount','Number of Store Discounts to Display','If more than zero, the  Welcome page (default-html5) or side panel (default-xhtml) will list this many store discounts. A store discount is a global discount that applies to the entire cart rather than to a specific item in the cart. Set at 0 to suppress the display of the discounts in the panel.','HEADERANDSIDEPANEL','integerValue',3,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('luceneIndexDir','Lucene Index Directory','If this setting starts with /WEB-INF, it represents a path under the installation directory. If not, it represents the full server path to the directory of the search index. The directory must be writable by the owner of the application server process.','LUCENE','mediumValue',NULL,NULL,'/WEB-INF/lucene',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('luceneAnalyzer','Lucene Analyzer','The textual Analyzer used by Lucene to index content and parse queries. The Snowball Analyzer adds support for term stemming, such as matching plurals and lowercase terms with each other. After changing this setting, the advanced search index should be reindexed.','LUCENE','smallValue',NULL,'Standard',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchHighlightedExcerpts','Display Highlighted Excerpts?','If set to yes, below each search result, an excerpt of the most relevant parts of the textual content of each item will be displayed with the search term highlighted within.','LUCENE','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchNumberOfFragments','Number of Fragments in Highlighted Excerpts','The maximum number of fragments displayed in each excerpt. Each fragment is separated by an ellipsis (...).','LUCENE','integerValue',3,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchFragmentLength','Fragment Length in Highlighted Excerpts','The number of characters displayed surrounding the search term in each fragment of each excerpt. The value is not followed precisely, since the system attempts to divide the fragments at common boundaries such as words and sentences.','LUCENE','integerValue',100,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displayContactForm','Display Contact Form?','If true, the contact form will be displayed on the contact page. The contact form collects information from users and the results of each submission are emailed to the addresses defined below.','CONTACTFORM','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('contactFormValidatedFields','Contact Form: Validated Fields','A comma-separated list of fields that the contact form validates.','CONTACTFORM','textValue',NULL,NULL,NULL,'Email');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('contactFormRequiredFields','Contact Form: Required Fields','A comma-separated list of fields that the contact form requires.','CONTACTFORM','textValue',NULL,NULL,NULL,'First Name, Last Name, Email');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('contactFormPromptedFields','Contact Form: Prompted Fields','A comma-separated list of fields that the contact form prompts for.','CONTACTFORM','textValue',NULL,NULL,NULL,'First Name, Last Name, Organization, Email, Phone, Message');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('contactFormEmailCC','Contact Form: Email CC','A comma-separated list of email addresses that contact form submissions will be emailed to as CCs.','CONTACTFORM','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('contactFormEmailTo','Contact Form: Email To','A comma-separated list of email addresses that contact form submissions will be emailed to.','CONTACTFORM','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('contactFormEmailSubject','Contact Form: Email Subject','The subject of the emails produced by the contact form.','CONTACTFORM','mediumValue',NULL,NULL,'Contact Form Submission',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('contactFormEmailBCC','Contact Form: Email BCC','A comma-separated list of email addresses that contact form submissions will be emailed to as BCCs.','CONTACTFORM','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displayEstimatedShippingOnCartPage','Display Estimated Shipping on Cart Page','If true, an estimated shipping cost will be displayed on the cart page.','SHIPPING','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('defaultDeliveryCity','Default Delivery City','When displaying estimated shipping costs, if the customer has not entered a city for his delivery address, this setting will be used.','SHIPPING','smallValue',NULL,'New York',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('defaultDeliveryState','Default Delivery State','When displaying estimated shipping costs, if the customer has not entered a state for his delivery address, this setting will be used.','SHIPPING','smallValue',NULL,'NY',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('defaultDeliveryZIP','Default Delivery ZIP','When displaying estimated shipping costs, if the customer has not entered a ZIP for his delivery address, this setting will be used.','SHIPPING','smallValue',NULL,'10001',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('defaultDeliveryCountry','Default Delivery Country','When displaying estimated shipping costs, if the customer has not entered a country for his delivery address, this setting will be used.','SHIPPING','smallValue',NULL,'US',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('estimatedShippingPromptOnCartPage','Prompt for Estimated Shipping Delivery Information?','If true, instead of using the above delivery defaults for estimated shipping, a form will appear on the cart page prompting the user to enter in delivery information.','SHIPPING','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('possibleOrderStatuses','Possible Order Statuses','A comma-separated list of order statuses that will populate drop downs in the admin area.','ADVANCEDSYSTEM','textValue',NULL,NULL,NULL,'Received, On Hold, Processed, Shipped, Canceled, Complete');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('possibleCustomerStatuses','Possible Customer Statuses','A comma-separated list of customer statuses that will populate drop downs in the admin area.','ADVANCEDSYSTEM','textValue',NULL,NULL,NULL,'Registered, Unapproved, Approved, Member, Premium Member, Bronze, Silver, Gold, Platinum');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('maxAdminRecordsToDisplay','Maximum Admin Records to Display','The maximum number of records to display in various drop down menus in the Administrator. When the number of records exceeds this value, users must enter in database identifiers directly. For example, if this value is 1000, up to 1000 categories will be displayed in the Product details form for the Primary Category field. If the number of categories is more than 1000, instead of a drop down menu, users will see a text box where they can edit the value using the database identifier of the category.','ADVANCEDSYSTEM','integerValue',1000,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeShippingMethodNameWithOrder','Store Shipping Method Name with Order','If true, the shipping method name chosen by the customer will be stored with the order, in the delivery status details field. Otherwise, the shipping method code will be stored.','SHIPPING','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('unsafeCharacters','Unsafe Characters','Characters that the system will prevent users from using for various Code fields in the system. Most code fields might have to appear on a URL or within a form submission. As such certain reserved characters should not be used for these fields.','ADVANCEDSYSTEM','mediumValue',NULL,NULL,'$&+,/:;=?@ "<>#%{}|^~[]`',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('possiblePrintTemplates','Possible Print Templates','A comma-separated list of templates that may be used to print orders with in the admin area. Each value corresponds to a .jsp file in the /WEB-INF/templates/administrator/[default or custom]/print directory.','ADVANCEDSYSTEM','textValue',NULL,NULL,NULL,'invoice, packList');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('possibleEmailTemplates','Possible Email Templates','A comma-separated list of templates that may be used for sending order status emails to customers within the admin area. Each value corresponds to a .jsp file in the /WEB-INF/templates/administrator/[default or custom]/emails directory.','ADVANCEDSYSTEM', 'textValue',NULL,NULL,NULL,'shipped, followup');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('insertGoogleAnalytics','Insert Google Analytics Tracking','If true, store pages will insert the Google Analytics script below for tracking page hits.','TRACKING','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('googleAnalyticsCode','Google Analytics Tracking Code','The Google Analytics tracking code for this site. Available within your Google Analytics account settings.','TRACKING','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('maxItemsPerOrder','Maximum Number of Items Per Order','The maximum number of items shoppers are allowed to put in their cart and order. To prevent an individual session from overwhelming the system, this setting specifies the maximum number of order items that may be added to a cart. (This is not the quantity of items ordered, but the number of line items for the order.)','ADVANCEDSYSTEM', 'integerValue',1000,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('skipDiscountsAndShippingOnItemEdit','Skip Discounts and Shipping on Item Edit','To optimize the processing involved with editing a cart item, set this flag to true. If true, the system will reprocess discounts and shipping just once when an item is edited or removed at the end of the process.','ADVANCEDSYSTEM', 'booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxURL','AvaTax URL','The URL to the AvaTax online service. Use <tt>https://development.avalara.net</tt> for development and testing. Use <tt>https://avatax.avalara.net</tt> for production.','AVATAX', 'mediumValue',NULL,NULL,'https://development.avalara.net',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxAccount','AvaTax Account Number','Your Avalara AvaTax account number.','AVATAX', 'smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxLicense','AvaTax License Key','Your Avalara AvaTax license key.','AVATAX', 'smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxCompanyCode','AvaTax Company Code','The company code sent by the system with requests to Avalara. This must match the Company Code set up in the AvaTax dashboard. If left blank it will attempt to find a default company in the AvaTax dashboard.','AVATAX', 'smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxDocCodePrefix','AvaTax Doc Code Prefix','The prefix of the doc code sent by the system with requests to Avalara. It will be prepended to the order ID of the order being processed.','AVATAX', 'smallValue',NULL,'TaxRequest-',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxDocType','AvaTax Action During Checkout','The action taken on the AvaTax system when the customer goes through checkout and taxes are retrieved.','AVATAX', 'smallValue',NULL,'SalesOrder',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxActionNewOrder','AvaTax Action with New Order','The action taken with the AvaTax system when a new order is completed.','AVATAX', 'smallValue',NULL,'Save',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxActionForOrderBeingShipped','AvaTax Action for Shipped Orders','The action taken with the AvaTax system when an order is shipped. This is defined by when the order status changes to the value defined by the AvaTax Status for Shipped Orders setting.','AVATAX', 'smallValue',NULL,'DoNothing',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxOrderStatusForBeingShipped','AvaTax Status for Shipped Orders','The status of a shipped order. When the order status changes to this value, the action defined by the AvaTax Action for Shipped Orders setting will be taken with the AvaTax system.','AVATAX', 'smallValue',NULL,'Shipped',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxCustomerCode','AvaTax Customer Code Prefix','The prefix of the customer code sent by the system with requests to Avalara. It will be prepended to the customer ID of the order being processed, or if the customer is not logged in, the order ID.','AVATAX', 'smallValue',NULL,'Customer-',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxSalespersonCode','AvaTax Salesperson Code','The optional salesperson code sent by the system with requests to Avalara.','AVATAX', 'smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxLocationCode','AvaTax Location Code','The optional location code sent by the system with requests to Avalara.','AVATAX', 'smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxDefaultTaxCode','AvaTax Default Tax Code','The AvaTax Tax Code to be used by default for each line of each order. Leave blank to not submit a tax code with each line item (AvaTax will assign U0000000, or unknown, if left blank).','AVATAX', 'smallValue',NULL,'U0000000',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxShippingTaxCode','AvaTax Shipping Tax Code','The AvaTax Tax Code to be used for the shipping line of each order.','AVATAX', 'smallValue',NULL,'FR',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxOriginLine1','Origin Address Line 1','Line 1 of the origin address for the shipment.','AVATAX', 'mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxOriginLine2','Origin Address Line 2','Line 2 of the origin address for the shipment.','AVATAX', 'mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxOriginLine3','Origin Address Line 3','Line 3 of the origin address for the shipment.','AVATAX', 'mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxOriginCity','Origin Address City','The city of the origin address for the shipment.','AVATAX', 'mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxOriginRegion','Origin Address Region','The state or province of the origin address for the shipment. For US states, use the two-character code such as NY, CA, etc.','AVATAX', 'mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxOriginPostalCode','Origin Address Postal Code','The postal code of the origin address for the shipment. For the US, use the ZIP code.','AVATAX', 'mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxOriginCountry','Origin Address Country','The country of the origin address for the shipment. For the US, use USA.','AVATAX', 'mediumValue',NULL,NULL,'USA',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxCountriesToVerify','AvaTax Countries to Validate Addresses For','A list of the countries that should be sent to AvaTax for address validation. If the delivery address for the customer matches one of these countries, the system will perform address validation. If the delivery address comes back as invalid, an error message will be shown to the customer during checkout asking him to double check the address. If it comes back as valid but only with modifications, the system will modify the delivery address for the customer. If the country does not match, no validation is done and if an invalid address is used, the system will fall back to using Basic Tax Rates.','AVATAX', 'textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxStatesToCalculate','AvaTax States to Calculate Tax For','A list of the states in the US and provinces in Canada that should be sent to AvaTax for tax processing. If the delivery address for the customer is in the US or Canada and does not match one of these states, the system will fall back to using Basic Tax Rates to compute the tax.','AVATAX', 'textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxCountriesToCalculate','AvaTax Countries to Calculate Tax For','A list of the countries that should be sent to AvaTax for tax processing. If the delivery address for the customer does not match one of these countries, the system will fall back to using Basic Tax Rates to compute the tax.','AVATAX', 'textValue',NULL,NULL,NULL,'US,CA');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxCustomerExtra1IsTaxExemptNumber','Use Customer Extra 1 as Tax Exempt Number?','Use the Extra 1 field in the customer record for the tax exempt number of the customer?','AVATAX', 'booleanValue','0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('avataxProductExtra1IsTaxCode','Use Product Extra 1 as Tax Code?','Use the Extra 1 field in the product record as the tax code for the product?','AVATAX', 'booleanValue','0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerClientID','Client ID','The client ID of the SoftSlate Emailer account.','ADVANCEDSYSTEM', 'smallValue',NULL,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerContactForm','Create Subscribers from Contact Form','Define if and how subscribers in the SoftSlate Emailer system should be created when users submit the contact form. (Manage other contact form settings from the <a href="SettingsContactForm.do">Contact Form Settings screen</a>.)','EMAILERCONTACT', 'smallValue',NULL,'dontSubscribe',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerContactFormOptInPrompt','Contact Form Opt In Prompt','If the above setting, Create Subcribers from Contact Form, is set to Subscribe Only Users Who Opt In, a field will appear on the contact form allowing customers to approve being added to the subscriber list. This setting defines the prompt that appears next to the field.','EMAILERCONTACT', 'mediumValue',NULL,NULL,'Would you like to be emailed updates and other information about our products and services?',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerContactFormListName','Contact Form Subscriber List Name','The name of the subscriber list in the SoftSlate Emailer system that users who sign up from the contact form should be added to. You do not need to create the list in the SoftSlate Emailer account. If it does not already exist, a new list will be created as the first user signs up. (The consolidate subscribers, simply make this list name the same as the one used for the Customer Registrations or Checkout.)','EMAILERCONTACT', 'mediumValue',NULL,NULL,'Online Store Email List',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerContactFormMultipleListPrompt','Contact Form Multiple List Prompt','This setting defines the prompt that appears next to the set of checkboxes asking the user to sign up for multiple lists, as defined in the below setting, Contact Form Multiple List Options.','EMAILERCONTACT', 'mediumValue',NULL,NULL,'Sign up for the following',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerContactFormMultipleListOptions','Contact Form Multiple List Options','In addition to putting all subscribers into the same list, you can present users a series of lists they can sign up for. Populate this field with a pipe-separated (|) list of newsletters or other lists the users can sign up for. If any of the lists do not already exist, a new list will be created as the first user signs up. Eg.: Monthly Newsletter|Special Bulletins|Letters from the President','EMAILERCONTACT', 'textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerContactFormConfirmOptIns','Confirm Contact Form Double Opt-In?','If set to yes, the SoftSlate Emailer system will produce an email to the user, which the user must open and click inside to confirm that he wishes to be added to the list (double opt-in). Note that this setting must be adjusted directly in the SoftSlate Emailer system if the subscriber list has already been created.','EMAILERCONTACT', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerCustomerRegistration','Create Subscribers As Customers Register','Define if and how subscribers in the SoftSlate Emailer system should be created when users create a customer account.','EMAILERREGISTRATION', 'smallValue',NULL,'dontSubscribe',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerCustomerRegistrationOptInPrompt','Customer Registration Opt In Prompt','If the above setting, Create Subscribers As Customers Register, is set to Subscribe Only Users Who Opt In, a field will appear on the customer registration form allowing customers to approve being added to the subscriber list. This setting defines the prompt that appears next to the field.','EMAILERREGISTRATION', 'mediumValue',NULL,NULL,'Would you like to be emailed updates and other information about our products and services?',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerCustomerRegistrationListName','Customer Registration Subscriber List Name','The name of the subscriber list in the SoftSlate Emailer system that users who sign up as they register should be added to. You do not need to create the list in the SoftSlate Emailer account. If it does not already exist, a new list will be created as the first user signs up. (The consolidate subscribers, simply make this list name the same as the one used for the Contact Form or Checkout.)','EMAILERREGISTRATION', 'mediumValue',NULL,NULL,'Online Store Email List',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerCustomerRegistrationConfirmOptIns','Customer Registration Double Opt-In?','If set to yes, the SoftSlate Emailer system will produce an email to the user, which the user must open and click inside to confirm that he wishes to be added to the list (double opt-in). Note that this setting must be adjusted directly in the SoftSlate Emailer system if the subscriber list has already been created.','EMAILERREGISTRATION', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerCheckout','Create Subscribers During Checkout','Define if and how subscribers in the SoftSlate Emailer system should be created when users go through checkout (specifically, submit the Checkout Addresses screen).','EMAILERCHECKOUT', 'smallValue',NULL,'dontSubscribe',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerCheckoutOptInPrompt','Checkout Opt In Prompt','If the above setting, Create Subscribers During Checkout, is set to Subscribe Only Users Who Opt In, a field will appear on the Checkout Addresses screen allowing customers to approve being added to the subscriber list. This setting defines the prompt that appears next to the field.','EMAILERCHECKOUT', 'mediumValue',NULL,NULL,'Would you like to be emailed updates and other information about our products and services?',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerCheckoutListName','Checkout Subscriber List Name','The name of the subscriber list in the SoftSlate Emailer system that users who sign up during checkout should be added to. You do not need to create the list in the SoftSlate Emailer account. If it does not already exist, a new list will be created as the first user signs up. (The consolidate subscribers, simply make this list name the same as the one used for the Contact Form or Customer Registrations.)','EMAILERCHECKOUT', 'mediumValue',NULL,NULL,'Online Store Email List',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('emailerCheckoutConfirmOptIns','Checkout Double Opt-In?','If set to yes, the SoftSlate Emailer system will produce an email to the user, which the user must open and click inside to confirm that he wishes to be added to the list (double opt-in). Note that this setting must be adjusted directly in the SoftSlate Emailer system if the subscriber list has already been created.','EMAILERCHECKOUT', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('giftCertificateAmountAttributeCode','Gift Certificate Amount Attribute Code','The code of the Attribute in the system representing the amount of a purchased Gift Certificate in the store. The system will automatically create a new Discount representing the Gift Certificate whenever an item is ordered that has this attribute.','DISCOUNT','mediumValue',NULL,NULL,'GiftCertificateAmount',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('excludeGiftCertificatesFromDiscounts','Exclude Gift Certificates from Discounts?','If true, the value of any Gift Certificates being purchased will not be included when computing a global discount. This is advisable since Gift Certificates themselves are not typically discounted.','DISCOUNT','booleanValue','1',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('giftCertificateExpireInDays','Gift Certificate Expire In Days','The amount of days from purchase a Gift Certificate is valid for. (Eg., 730 means the Gift Certificate may be used for up to two years after it is purchased after which it may no longer be redeemed.) A value of zero means unlimited. The expiration date of the Discount representing the Gift Certificate will be set according to this value.','DISCOUNT','integerValue','730',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('giftCertificateNotificationCC','Gift Certificate Notification CC','A comma-separated list of email addresses that will be copied on gift certification notification emails.','DISCOUNT','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('giftCertificateNotificationBCC','Gift Certificate Notification BCC','A comma-separated list of email addresses that will be blind copied on gift certification notification emails.','DISCOUNT','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('displayAccountDownloadsLink','Display Account Downloads Link','If set to yes, the Downloads tab in the customer account area will appear, where the customer can access virtual (downloadable) products he has purchased.','CUSTOMERACCOUNT','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('allowCustomerWishLists','Allow Wish Lists for Customers','If true, customers will be able to create wish lists. Add custom setting allowCustomerWishLists = false on individual products to override.','CUSTOMERACCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('maxCustomerWishLists','Max Customer Wish Lists','The maximum number of wish lists a customer can have.','CUSTOMERACCOUNT','integerValue',10,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('maxProductsPerWishLists','Max Products Per Wish Lists','The maximum number of products that can be added to a single wish list.','CUSTOMERACCOUNT','integerValue',20,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('wishListPageSize','Wish List Page Size','The number of products to display per page of a wish list page.','PRODUCTLISTDISPLAY','integerValue',9,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('logRequestsToDatabase','Log Requests to the Database','If true, the request log table in the database, sscRequestLog, will be populated with basic information about every request, which is accessible via the <a href="RequestLog.do">Request Log area</a> of Administrator interface. Otherwise, the information may be logged to files using log4j.properties.','ADVANCEDSYSTEM', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('deriveCreditCardTypeFromNumber','Derive Credit Card Type from Number','If enabled, the system will not prompt shoppers for the credit card type (Visa, MasterCard, etc). Instead, the system will derive the type from the card number.','PAYMENTS', 'booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('enableProductReviews', 'Enable Product Reviews?', 'If set to yes, customers will be able to view reviews made by other customers and submit their own reviews. All reviews must be approved by an administrator before being displayed. Use the <a href="SettingsEmail.do">Outgoing Emails screen</a> to define who receives email notifications of newly submitted reviews.', 'CUSTOMERACCOUNT', 'booleanValue', 1, NULL, NULL, NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('productReviewEmailTo', 'Product Review Notification Email To', 'A comma-separated list of administrator email addresses newly submitted product reviews get sent to for approval.', 'EMAIL', 'textValue', NULL, NULL, NULL, '');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('productReviewEmailSubject', 'Product Review Email Subject', 'Administrator Product Review Email Subject', 'EMAIL', 'mediumValue', 0, NULL, 'New Product Review - Please Approve', NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('productReviewEmailFrom', 'Product Review Email From', 'The "From" address used for product review notification emails. If left blank the Store Email Address will be used.', 'EMAIL', 'mediumValue', 0, NULL, '', NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('automaticallyResizeImages', 'Automatically Resize Images?', 'When uploading a large product image, should the system automatically resize it to the below large, medium, and small sizes? Resizing will only occur when the large image for a product is uploaded. If this setting is set to true and the small and medium images do not exist already, they will be automatically created when the large image is uploaded. (Note that when uploading Additional Images, small, medium, and large versions will always be generated even if this setting is set to no.)', 'ADVANCEDDISPLAY', 'booleanValue', '1', NULL, NULL, NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('smallImageSize', 'Small Image Size', 'When uploading a large product image or an additional product image, the size the small version of the image will be sized at. The aspect ratio of the image is maintained. This setting represents the maximum width or height, whichever is greater, of the resulting image. If this is set to 0, the uploaded image will be copied into the small image unchanged.', 'ADVANCEDDISPLAY', 'integerValue', '100', NULL, NULL, NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('mediumImageSize', 'Medium Image Size', 'When uploading a large product image or an additional product image, the size the medium version of the image will be sized at. The aspect ratio of the image is maintained. This setting represents the maximum width or height, whichever is greater, of the resulting image. If this is set to 0, the uploaded image will be copied into the medium image unchanged.', 'ADVANCEDDISPLAY', 'integerValue', '300', NULL, NULL, NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('largeImageSize', 'Large Image Size', 'When uploading a large product image or an additional product image, the size the large version of the image will be sized at. The aspect ratio of the image is maintained. This setting represents the maximum width or height, whichever is greater, of the resulting image. If this is set to 0, the uploaded image will be copied into the large image unchanged.', 'ADVANCEDDISPLAY', 'integerValue', '550', NULL, NULL, NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('licenseKey','SoftSlate Commerce License Key','The license key(s) for this installation of SoftSlate Commerce. (Enter multiple license keys separated by new lines.)','LICENSEKEY', 'textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchEnableFacetedSearch','Enable Faceted Search','If set to yes, a menu of facets and counts related to each search will appear.','LUCENE', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchNumberOfFacetsToDisplay','Number Of Facets To Display','The maximum number of facet value options to display in the customer interface under each facet.','LUCENE', 'integerValue',20,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchFacetTreeDepth','Facet Category Tree Depth Searched For','The maximum levels deep to retrive facet information for for the category tree. Unless you are concerned about performance and have a deep category tree, set this to a high number.','LUCENE', 'integerValue',10,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchFacetTreeDepthDisplayed','Facet Category Tree Depth Displayed','The maximum number of nested levels to display for categories in the faceted search widget. Use this number to control how many nested category levels should be displayed in the faceted search widget.','LUCENE', 'integerValue',2,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchDisplayFacetedSearchWidget','Display Faceted Search Wigdet','If faceted search is enabled, displays the faceted search widget in the sidebar, allowing the customer to further refine his search.','HEADERANDSIDEPANEL,LUCENE', 'booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchPriceRangeNumberOfLevels','Maximum Number of Price Ranges','If faceted search is enabled, determines the maximum number of price range options listed in the Faceted Search Widet. The price for each product is determined solely by the unit price field for the product (no attribute or option prices are considered). To suppress this facet from being displayed at all, set this value to zero. Whenever this field changes you must reindex for it to take effect.','LUCENE', 'integerValue',5,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchPriceRangeMultiplier','Price Range Multiplier','The multiplier used for the price range options listed in the Faceted Search Widet. For example, if the multiplier is set to 25 and the Maximum Number of Price Ranges is 5, the price range options will include 0-25, 25-50, 50-100, 100-200, and 200+.','LUCENE', 'integerValue',25,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('hideCategoryTreeWhenFacetsToDisplay','Hide Category Tree When Facets to Display','If faceted search is enabled and the Faceted Search Widet is set to display, hide the category tree to make more room for the Faceted Search Widet. (default-xhtml only.)','HEADERANDSIDEPANEL,LUCENE', 'booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('heightOfEachFacetInWidget','Height of Each Facet in Widget','The height of each facet displayed in the widget will be set at this many pixels, and a scrollbar will be used to scroll through the facet values. Set to 0 to not restrict the height at all.','HEADERANDSIDEPANEL,LUCENE', 'integerValue',500,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('loadFacetCategoriesFromDatabase','Load Facet Categories from Database','Specifies if the category objects corresponding to facets should be loaded from the database. If false, the categories are looked up via the cached categories from the category tree for a performance improvement. (Note: facet manufacturers are always loaded from the database.)','LUCENE', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('allowCustomersToSubmitMultipleReviewsPerProduct', 'Allow Customers to Submit More than One Review Per Product?', 'If set to yes, customers will be able to submit more than one review for each product in the store. All reviews must be approved by an administrator before being displayed.', 'CUSTOMERACCOUNT', 'booleanValue', 0, NULL, NULL, NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useAjaxForFacetedSearch', 'Use Ajax for Faceted Search', 'Use Ajax when checkboxes are clicked in the Faceted Search Widget, to refresh the product list and facet counts in the other facet groups. If this is not enabled, a regular HTML form will be employed by the Faceted Search Widget.', 'LUCENE', 'booleanValue', 1, NULL, NULL, NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('allowAddressBook','Allow Address Book for Customers','If true, customers will be able to create multiple delivery addresses in their account and choose any one of them when placing an order. (Requires JavaScript to be enabled.)','CUSTOMERACCOUNT','booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('maxCustomerAddressBook','Max Addresses per Customer','The maximum number of addresses a customer can have in the address book.','CUSTOMERACCOUNT','integerValue',10,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchMatchStyle','Advanced Search Match Style','The technique the system should use to match documents during Lucene searches inputted by users. They are listed in rough order from narrowest to broadest.','LUCENE', 'smallValue',NULL,'anyTermFuzzy',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchFuzziness','Advanced Search Fuzziness','A factor from 0.0 to 1.0 that tells the system how fuzzy fuzzy searches should be. A higher value will cause fuzzy searches to be less fuzzy (ie, narrower). A lower value will cause fuzzy searches to be broader. This setting only applies if a fuzzy option is chose in the Advanced Search Match Style setting.','LUCENE', 'smallValue',NULL,'0.50',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('initializeGuice','Initialize Guice?','Initialize and create bindings from appComponents.properties and appComponents-custom.properties for Google Guice for object creation and dependency injections. Requires creating the Guice servlet filter and mapping in web.xml as described here: http://www.softslate.com/documentation/html/threedotthreezero.html','ADVANCEDSYSTEM', 'booleanValue','0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useTinyMCE','Use TinyMCE Rich Text Editor?','If yes, the system will use the TinyMCE rich-text editor on admin forms that ask for HTML content, such as category and product descriptions. If no, the legacy YUI Rich Text Editor will be available for those fields.','ADVANCEDSYSTEM','booleanValue','1',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('contingencyShippingMethodCode','Contingency Shipping Method Code','The Shipping Method code corresponding to the shipping method that should be used as a contingency, when the rating service from FedEx, USPS, or UPS is down, or when any other exception is encountered retrieving rates from those services. This method should be marked as inactive if you do not want it to appear to customers normally.','SHIPPING', 'smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('shippingCutoffHour','Shipping Cutoff Hour','The time of day after which an order must be shipped out the following day. This is used to calculate estimated shipping days. Orders that arrive late in the day typically must be shipped out the next day. Set this value to the time after which the order must be shipped out the following day. Must be in 24-hour format. Eg. 14:00 for 2pm.','SHIPPING','smallValue',NULL,'14:00',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('orderStatusForCapturingPayments','Order Status for Capturing Payments','When an order status is changed to this value, the system will attempt to capture a previously-authorized payment, if the payment processor used for the order supports the function.','PAYMENTS', 'smallValue',NULL,'Shipped',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('capturePaymentsWhenOrderStatusChanges','Capture Payments When Order Status Changes?','When an order status is changed to the above Order Status for Capturing Payments value, attempt to capture a previously-authorized payment, if the payment processor used for the order supports the function. This setting turns the feature on and off.','PAYMENTS', 'booleanValue',1,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('preventStatusChangeIfPaymentCaptureFails','Prevent Status Change If Payment Capture Fails','If yes, when an order status is changed to the value represented by the Order Status for Capturing Payments setting, and the payment capture fails, the status change will be prevented.','PAYMENTS', 'booleanValue','1',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useAdvancedLostPassword','Use Advanced Lost Password Method?','If yes, the system will send the user a link with a temporary token via email.   They must click the link and then can change their password on the form.','CUSTOMERACCOUNT','booleanValue','1',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('tokenExpirationPeriod', 'Customer Password Token Expiration', 'The amount of hours that the user has to reset his password with a reset link.', 'CUSTOMERACCOUNT', 'integerValue', 4, NULL, NULL, NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('sortByNumericValue','Facets to Sort By Numeric Value','A comma-separated list of Facet names whose values should be sorted by numeric value. The default sort for facets is to sort by the count of matching products. This setting overrides that behvavior for the given facets, if their values can be cast as numbers (eg, prices or ratings) where it makes more sense to sort by the values themselves. Add ASC or DESC to specify the sort should be from lowest to highest (ASC), or vice-versa (DESC).','LUCENE','textValue',NULL,NULL,NULL,'priceRange ASC, averageRating DESC');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('sortByNaturalValue','Facets to Sort By Alphabetical Value','A comma-separated list of Facet names whose values should be sorted by alphabetical value. The default sort for facets is to sort by the count of matching products. This setting overrides that behvavior for the given facets, if it makes more sense to sort by the values themselves. Add ASC or DESC to specify the sort should be from lowest to highest (ASC), or vice-versa (DESC).','LUCENE','textValue',NULL,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useImageVerificationWithRegistrations','Use Captcha Verification with Registrations','If true, new customers creating accounts will be required to pass a Captcha test.','CAPTCHAVERIFICATION','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useImageVerificationWithCCInfo','Use Captcha Verification with Credit Card Form','If true, customers entering credit card information will be required to pass a Captcha test.','CAPTCHAVERIFICATION','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useImageVerificationWithAdminLogins','Use Captcha Verification with Administrator Logins','If true, administrators logging in will be required to pass a Captcha test.','CAPTCHAVERIFICATION','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useImageVerificationWithContactForms','Use Captcha Verification with the Contact Form','If true, users submitting the contact form will be required to pass a Captcha test.','CONTACTFORM,CAPTCHAVERIFICATION','booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('useLegacyCaptchaMethod','Use Legacy Captcha Verification Method','Is true, the system will use the legacy JCaptcha method for image verifications. The preferred method is Google reCAPTCHA. To sign up and obtain a site key and secret key, go here: <a target="_new" href="https://www.google.com/recaptcha/admin#list">https://www.google.com/recaptcha/admin#list</a>.','CAPTCHAVERIFICATION','booleanValue','0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('recaptchaVerificationURL','reCAPTCHA Verification URL','The URL the system uses to verify reCAPTCHA inputs. This typcially will not change.','CAPTCHAVERIFICATION','mediumValue',NULL,NULL,'https://www.google.com/recaptcha/api/siteverify',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('recaptchaSiteKey','reCAPTCHA Site Key','The site key provided by Google when you sign up for reCAPTCHA.','CAPTCHAVERIFICATION','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('recaptchaSecretKey','reCAPTCHA Secret','The secret key the system uses to verify reCAPTCHA inputs, provided by Google when you sign up for reCAPTCHA. ','CAPTCHAVERIFICATION','mediumValue',NULL,NULL,'',NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchEnableSuggestions','Enable Suggestions','If set to yes, a index of pop-up suggestions for the search box will be generated whenever Advanced Search is indexed.','LUCENE', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchEnableProductSuggestions','Enable Product Suggestions','If set to yes, products matching the user input will be included in the popup of suggestions under the search box.','LUCENE', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchEnableCategorySuggestions','Enable Category Suggestions','If set to yes, categories matching the user input will be included in the popup of suggestions under the search box.','LUCENE', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchEnableManufacturerSuggestions','Enable Manufacturer Suggestions','If set to yes, manufacturers matching the user input will be included in the popup of suggestions under the search box.','LUCENE', 'booleanValue',0,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchSuggestionsMatchStyle','Advanced Search Suggestions Match Style','The technique the system should use to match suggestions in the Lucene Suggestions Index. They are listed in rough order from narrowest to broadest.','LUCENE', 'smallValue',NULL,'prefixWildcard',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchSuggestionsFuzziness','Advanced Search Suggestions Fuzziness','A factor from 0.0 to 1.0 that tells the system how fuzzy suggestion searches should be. A higher value will cause fuzzy suggestion searches to be less fuzzy (ie, narrower). A lower value will cause fuzzy searches to be broader. This setting only applies if a fuzzy option is chose in the Advanced Search Suggestions Match Style setting.','LUCENE', 'smallValue',NULL,'0.50',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchSuggestionsMaxResults','Advanced Search Suggestions Max Results','The maximum number of suggestions to return from a search against the Suggestions Index.','LUCENE', 'integerValue',50,NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('storeLocale','Store Locale','If not blank, the locale for the store used to format messages and currency will be forced to this value. Eg: en-US. If left blank, the locale identified by the browser request header will be used.','ADVANCEDSYSTEM', 'smallValue',NULL,'',NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('enableAPIRequests','Enable API Requests?','Enables API requests to /api. (Documentation at /administrator/apiReference/index.html.) Turn this off to prevent API calls to the system globally.','ADVANCEDSYSTEM', 'booleanValue', '0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchProductFieldsToIndex','Product Fields to Index','The fields from each product record that should be indexed and searched on. For backwards compatibility, all string fields will be indexed if none are selected.','LUCENE', 'textValue',0,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchAttributeFieldsToIndex','Attribute Fields to Index','The fields from each attribute record that should be indexed and searched on. For backwards compatibility, all string fields will be indexed if none are selected.','LUCENE', 'textValue',0,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchCategoryFieldsToIndex','Category Fields to Index','The fields from each category record that should be indexed and searched on. For backwards compatibility, all string fields will be indexed if none are selected.','LUCENE', 'textValue',0,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('advancedSearchManufacturerFieldsToIndex','Manufacturer Fields to Index','The fields from each manufacturer record that should be indexed and searched on. For backwards compatibility, all string fields will be indexed if none are selected.','LUCENE', 'textValue',0,NULL,NULL,'');
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('sessionTimeoutAdministrators','Timeout in Minutes for Administrator Sessions','The length of administrator sessions, ie, the number of minutes of inactivity before the session is killed on the server. Set to 0 to default to the container default (15-20 minutes for Tomcat) or the config in web.xml.','SESSION', 'integerValue', '0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('sessionTimeoutCustomers','Timeout in Minutes for Customer Sessions','The length of customer sessions, ie, the number of minutes of inactivity before the session is killed on the server. Set to 0 to default to the container default (15-20 minutes for Tomcat) or the config in web.xml.','SESSION', 'integerValue', '0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('IncompleteOrdersJob-isOn','Incomplete Orders Job - Is On','Turn the job on or off','IncompleteOrdersJob', 'booleanValue','0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('IncompleteOrdersJob-olderThanDays','Incomplete Orders Job - Older Than Days','Delete incomplete orders older than this many days.','IncompleteOrdersJob','integerValue','90',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('IncompleteOrdersJob-olderThanHours','Incomplete Orders Job - Older Than Hours','In addition to the number of days, delete incomplete orders older than this many hours.','IncompleteOrdersJob','integerValue','0',NULL,NULL,NULL);
INSERT INTO sscSetting (code, name, description, type, valueType, integerValue, smallValue, mediumValue, textValue) VALUES ('areTaxRatesPercentages','Are Tax Rates Percentages?','If set to yes, the values stored for the rate field in Basic Tax Rates should be in the form of a percentage like 8.00. If no, the values should be stored in the form of a decimal like 0.08.','TAXES','booleanValue',1,NULL,NULL,NULL);
